<?php
    //==================================================//
    function CheckTargeting(&$info,$id_go,$rule){
        global $user_agent, $ip, $wapver;
        $user_agentl=strtolower($user_agent);
        // 
        $hour=(int)date("H",time());
        // 
        $day=(int)date("d",time());

        //  
        $pathrule="data/rules/";

        //    
        $namehourclick=$pathrule.$id_go."_hour_".$hour.".log";
        //  
        $namedayclick=$pathrule.$id_go."_day_".$day.".log";
        $namelog=$pathrule."log_".date("Y-m-d",time()).".log";
        $repeat=0;
        //  
        if(!empty($rule["time"])){
            if(empty($rule["time"][$hour]))return "time";
        };//if($rule["time"])
        //  
        if(!empty($rule["ver"])){
            if(empty($rule["ver"][$wapver]))return "ver";
        };
        //  
        if(!empty($rule["proxy"])){
            if((isset($_SERVER["HTTP_X_FORWARDED_FOR"]))||(isset($_SERVER["HTTP_CLIENT_IP"])))return "proxy";
        };//if($rule["proxy"])
        
        //  
        if(!empty($rule["cookie"])){
            if(isset($_COOKIE["gof_".$id_go]))return "cookie";
        };

        //   
        if((!empty($_GET["user"]))&&(!empty($rule["banuser"]))){
            if(!empty($rule["banuser"][(int)$_GET["user"]]))return "banuser";
        };//if($rule["banuser"])
    
        //   
        if(!empty($rule["agent"])){
            $nagent=count($rule["agent"]);
            $flag=true;
            for($i=0;$i<$nagent;$i++){
                if(empty($rule["agent"][$i]))continue;
                if(strpos($user_agentl,$rule["agent"][$i])!==false){
                    $flag=false;// 
                    break;
                };
            };
            if($flag)return "agent";
        };//if($rule["agent"])
        //   
        if(!empty($rule["banagent"])){
            $nagent=count($rule["banagent"]);
            $flag=false;
            for($i=0;$i<$nagent;$i++){
                if(empty($rule["banagent"][$i]))continue;
                if(strpos($user_agentl,$rule["banagent"][$i])!==false){
                    $flag=true;// 
                    break;
                };
            };
            if($flag)return "banagent";
        };//if($rule["banagent"])
    
        //   
        if(!empty($rule["ip"])){
            $nip=count($rule["ip"]);
            $flag=true;
            for($i=0;$i<$nip;$i++){
                if(empty($rule["ip"][$i]))continue;
                if(strpos($ip,$rule["ip"][$i])===0){
                    $flag=false;//    
                    break;
                };
            };//for
            if($flag)return "ip";
        };//if($rule["ip"])
        //   ip
        if(!empty($rule["banip"])){
            $nip=count($rule["banip"]);
            $flag=false;
            for($i=0;$i<$nip;$i++){
                if(empty($rule["banip"][$i]))continue;
                if(strpos($ip,$rule["banip"][$i])===0){
                    $flag=true;//    
                    break;
                };
            };//for
            if($flag)return "banip";
        };//if($rule["ip"])

        //    
        if((!empty($info["referer"]))&&(!empty($rule["banreferer"]))){
            $nreferer=count($rule["banreferer"]);
            $flag=false;
            for($i=0;$i<$nreferer;$i++){
                if(empty($rule["banreferer"][$i]))continue;
                if(strpos($info["referer"],$rule["banreferer"][$i])!==false){
                    $flag=true;// 
                    break;
                };
            };
            if($flag)return "banreferer";
        };//if($rule["banagent"])
    
        //   host
        if(!empty($rule["host"])){
            if(empty($info["host"])){
                $info["host"]=gethostbyaddr($ip);
            };
            $host=$info["host"];
            $nhost=count($rule["host"]);
            $flag=true;
            for($i=0;$i<$nhost;$i++){
                if(empty($rule["host"][$i]))continue;
                if(strpos($host,$rule["host"][$i])!==false){
                    $flag=false;//    
                    break;
                };
            };//for
            if($flag)return "host";
        };//if($rule["host"])
        //   host
        if(!empty($rule["banhost"])){
            if(empty($info["host"])){
                $info["host"]=gethostbyaddr($ip);
            };
            $host=$info["host"];
            $nhost=count($rule["banhost"]);
            $flag=false;
            for($i=0;$i<$nhost;$i++){
                if(empty($rule["banhost"][$i]))continue;
                if(strpos($host,$rule["banhost"][$i])!==false){
                    $flag=true;//    
                    break;
                };
            };//for
            if($flag)return "banhost";
        };//if($rule["host"])
//  ,     
        //  
        if(!empty($rule["operator"])){
            if(empty($info["operator"])){
                $info["operator"]=getoperatorGO($ip);
            };
            $operator=$info["operator"];
            $noperator=count($rule["operator"]);
            $flag=true;
            for($i=0;$i<$noperator;$i++){
                if(empty($rule["operator"][$i]))continue;
                if(strpos($operator,$rule["operator"][$i])!==false){
                    $flag=false;//    
                    break;
                };
            };//for
            if($flag)return "operator";
        };//if(!empty($rule["operator"]))
    
        if(!empty($rule["banoperator"])){
            if(empty($info["operator"])){
                $info["operator"]=getoperatorGO($ip);
            };
            $operator=$info["operator"];
            $noperator=count($rule["banoperator"]);
            $flag=false;
            for($i=0;$i<$noperator;$i++){
                if(empty($rule["banoperator"][$i]))continue;
                if(strpos($operator,$rule["banoperator"][$i])!==false){
                    $flag=true;//    
                    break;
                };
            };//for
            if($flag)return "banoperator";
        };//if(!empty($rule["banoperator"]))
    
        //    
        if(!empty($rule["hourclick"])){
            $data=@file_get_contents($namehourclick);
            //         ,   .
            $poss=strpos($data,"|");
            if($poss!==false){
                $oldtime=(int)substr($data,0,$poss);
                if($oldtime<time()-60*60){
                    $data="";
                    $fd=fopen($namehourclick,"wb");
                    fwrite($fd,"");
                    fclose($fd);
                };
            };//if($poss!==false)
            $rows=substr_count($data,"\n");
            if($rows>0){
                //    
                if($rule["hourclick_max"]){
                    $nclick=$rows;
                    if($nclick>=$rule["hourclick_max"])return "hourclick1";
                };
                //   IP
                if($rule["hourclick_maxip"]){
                    $nclick=substr_count($data,$ip);
                    if($nclick>=$rule["hourclick_maxip"])return "hourclick2";
                };
                //   
                if($rule["hourclick_maxagent"]){
                    $nclick=substr_count($data,$user_agentl);
                    if($nclick>=$rule["hourclick_maxagent"])return "hourclick3";
                };
                //   ip+
                if($rule["hourclick_maxipagent"]){
                    $nclick=substr_count($data,$ip."|".$user_agentl);
                    if($nclick>=$rule["hourclick_maxipagent"])return "hourclick4";
                };
                //    
                if($rule["hourclick_double"]){
                    $datadouble=explode("\n",$data);
                    $start=count($datadouble)-1;
                    if(empty($datadouble[$start]))$start--;
                    if($start>=0){
                        $flag=true;
                        $stop=$start-$rule["hourclick_double"];
                        if($stop<0)$stop=0;
                        for($i=$start;$i>$stop;$i--){
                            if(strpos($datadouble[$i],$ip."|".$user_agentl)===false){//  
                                $flag=false;break;
                            };
                        };
                        if($flag)return "hourclick5";
                    };//if($start>0)
                };//if($rule["hourclick_double"])
            };//if($rows>0)
        };//if($rule["hourclick"])
        //    
        if(!empty($rule["dayclick"])){
            $data=@file_get_contents($namedayclick);
            //        2 ,        
            $poss=strpos($data,"|");
            if($poss!==false){
                $oldtime=(int)substr($data,0,$poss);
                if($oldtime<time()-60*60*24*2){
                    $data="";
                    $fd=fopen($namedayclick,"wb");
                    fwrite($fd,"");
                    fclose($fd);
                };
            };//if($poss!==false)
            //   IP
            if($rule["dayclick_maxip"]){
                $nclick=substr_count($data,$ip);
                if($nclick>=$rule["dayclick_maxip"])return "dayclick1";
            };
            //   
            if($rule["dayclick_maxagent"]){
                $nclick=substr_count($data,$user_agentl);
                if($nclick>=$rule["dayclick_maxagent"])return "dayclick2";
            };
            //   ip+
            if($rule["dayclick_maxipagent"]){
                $nclick=substr_count($data,$ip."|".$user_agentl);
                if($nclick>=$rule["dayclick_maxipagent"])return "dayclick3";
            };
        };//if($rule["dayclick"])
    };
    //==================================================//
    function getoperatorGO($ip){
        include("baseip.php");
        $ip=IPnormal($ip);
        $nbase=count($dataip);
        for($i=0;$i<$nbase;$i++){
            $row=&$dataip[$i];
            if((strcmp($row[0],$ip)<=0)&&(strcmp($row[1],$ip)>=0))return $row[4];
        };
        return "other";
    };
?>