<?
/*
Выписка счетов на оплату и проверка их состояния.
Для работы нужен аттестат не ниже персонального.
Автор: вебмани :-)
Доработано: Denvas
http://bmatrix.net/
*/
//==================================================//
/*
Генерация подписи
*/
function wm_GetSign($inStr) { 
    global $wmWMSigner;
    $descriptorspec = array(
	0 => array("pipe", "r"),
	1 => array("pipe", "w"),
	2 => array("pipe", "r") );
    $process = proc_open($wmWMSigner, $descriptorspec, $pipes );
    if (is_resource($process)) {
	fwrite($pipes[0], "$inStr\004\r\n");
	fclose($pipes[0]);
	$s = fgets($pipes[1], 133);
	fclose($pipes[1]);
	$return_value = proc_close($process);
	if(strlen($s)<132){
	    die("WMSigner error: $s");
	};
	return $s;
    } else {
	    die("Error create WMSigner process");
	die();
    };
}
//==================================================//
/*
Запрос к серверу
*/
function wm_xmlHttpsReq($addr, $xml){ 
    global $wmURL, $wmCAcert, $wmType, $wmKey, $wmCert, $wmPass;
    $ch = curl_init($wmURL.$addr);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_POST,1);
    curl_setopt($ch, CURLOPT_POSTFIELDS,$xml);
    // Укажем путь к корневому сертификату WebMoney CA:
    curl_setopt($ch, CURLOPT_CAINFO, $wmCAcert);

    
    $result=curl_exec($ch);
    $fd=fopen("logs/invoice.log","ab");
    fwrite($fd,time()."\n".strtr($xml,array("\r"=>"","\n"=>"\\n"))."\n".strtr($result,array("\r"=>"","\n"=>"\\n"))."\n");
    fclose($fd);
    if( curl_errno($ch) != 0 ) {
	die('CURL_error: ' . curl_errno($ch) . ', ' . curl_error($ch));
    };
    curl_close($ch);
    return $result;
};
//==================================================//
/*
Генерация уникального ID
*/
function wm_ReqID(){
    $time=microtime();
    $int=substr($time,11);
    $flo=substr($time,2,5);
    return $int.$flo;
};
//==================================================//
/*
Проверка результата
*/
function wm_CheckResp($vals, $index){
        $retval_idx = $index['RETVAL'][0];
        if (!$retval_idx) die("Incorrect response (no retval)");
        $retval = $vals[$retval_idx]['value'];
	if ($retval != 0) {
	    $desc_idx = $index['RETDESC'][0];
	    if (!$desc_idx) die("Incorrect response (no retdesc)");
	    return $vals[$desc_idx]['value'];
	};
	return 0;
};
//==================================================//
/*
Проверка денег на кошельках
*/
function wm_X9Req(){
    global $wmType, $wmWMID;
    
    $reqID = wm_ReqID();
    
    $doc = domxml_new_doc('1.0');
    $root = $doc->create_element('w3s.request');
    $root = $doc->append_child($root);
    $tmp = $doc->create_element('reqn');
    $tmp->set_content($reqID);
    $root->append_child($tmp);
    $tmp = $doc->create_element('wmid');
    $tmp->set_content($wmWMID);
    $root->append_child($tmp);
    
	$tmp = $doc->create_element('sign');
	$tmp->set_content(wm_GetSign($wmWMID.$reqID));
	$root->append_child($tmp);
	$addr = 'XMLPurses.asp';
    
    $getpurses = $doc->create_element('getpurses');
    $root->append_child($getpurses);
    $tmp = $doc->create_element('wmid');
    $tmp->set_content($wmWMID);
    $getpurses->append_child($tmp);

    $request = $doc->dump_mem(TRUE);
    
    $result = wm_xmlHttpsReq($addr, $request);
    $xml_parser = xml_parser_create('UTF-8');
    xml_parse_into_struct($xml_parser, $result, $vals, $index);
    xml_parser_free($xml_parser);

    $check = wm_CheckResp($vals,$index);
    if( $check != 0) die($check);
    
    $purses = array();
    $pursename = '';
    $amount = '';
    $desc = '';
    for($n = 0; $n < count($vals); ++$n){
        $e = $vals[$n];
        switch ($e['tag']){
    	    case 'PURSE':
                switch ($e['type']){
                    case 'open':
                            $pursename = ''; $amount = ''; $desc = '';
                            break;
                    case 'close':
                            $purses[$pursename] = array('amount' => $amount, 'desc' => $desc);
                            break;
                }
                break;
            case 'PURSENAME':
                $pursename = $e['value'];
                break;
            case 'AMOUNT':
                $amount = $e['value'];
                break;
            case 'DESC':
                $desc = $e['value'];
                break;
        }
    }
    return $purses;    
};
//==================================================//
/*
Выписка счета
*/
function wm_X1Req($customerwmid,$storepurse,$amount,$desc,$address){
    global $wmType, $wmWMID;
    $orderid=time();
    $period=0;
    $expiration=3;
    $addr = "XMLInvoice.asp";
    $reqID = wm_ReqID();
    $sign=wm_GetSign($orderid.$customerwmid.$storepurse.$amount.$desc.strtr($address,array("&amp;"=>"&")).$period.$expiration.$reqID);
    $request="<?xml version=\"1.0\" encoding=\"windows-1251\"?><w3s.request><reqn>".$reqID."</reqn><wmid>".$wmWMID."</wmid><sign>".$sign."</sign><invoice><orderid>".$orderid."</orderid><customerwmid>".$customerwmid."</customerwmid><storepurse>".$storepurse."</storepurse><amount>".$amount."</amount><desc>".$desc."</desc><address>".$address."</address><period>".$period."</period><expiration>".$expiration."</expiration></invoice></w3s.request>";
    $result = wm_xmlHttpsReq($addr, $request);
    $xml_parser = xml_parser_create('UTF-8');
    xml_parse_into_struct($xml_parser, $result, $vals, $index);
    xml_parser_free($xml_parser);

    $check = wm_CheckResp($vals,$index);
    if( $check != 0) die($check);
    $wmtrans="";
    for($n = 0; $n < count($vals); ++$n){
        $e = $vals[$n];
        switch ($e['tag']){
    	    case 'INVOICE':
                if(strcmp($e["type"],"open")==0)$wmtrans=$e["attributes"]["ID"];
                break;
        };
    };
    return array($orderid,$wmtrans);
};
//==================================================//
/*
Проверка счета
*/
function wm_X4Req($purse,$wminvid){
    global $wmType, $wmWMID;
    $orderid="0";
    $datestart=date("Ymd H:i:s", time()-5*24*60*60);
    $datefinish=date("Ymd H:i:s", time());
    $addr = "XMLOutInvoices.asp";
    $reqID = wm_ReqID();
    $sign=wm_GetSign($purse.$reqID);
    $request="<?xml version=\"1.0\" encoding=\"windows-1251\"?><w3s.request><reqn>".$reqID."</reqn><wmid>".$wmWMID."</wmid><sign>".$sign."</sign><getoutinvoices><purse>".$purse."</purse><wminvid>".$wminvid."</wminvid><orderid>".$orderid."</orderid><datestart>".$datestart."</datestart><datefinish>".$datefinish."</datefinish></getoutinvoices></w3s.request>";

    $result = wm_xmlHttpsReq($addr, $request);
    $xml_parser = xml_parser_create('UTF-8');
    xml_parse_into_struct($xml_parser, $result, $vals, $index);
    xml_parser_free($xml_parser);
    /*
    $check = wm_CheckResp($vals,$index);
    if( $check != 0) die($check);
    */
    $state=-1;$customerwmid="";
    for($n = 0; $n < count($vals); ++$n){
        $e = $vals[$n];
        switch ($e['tag']){
    	    case 'STATE':
                $state=$e['value'];
                break;
    	    case 'CUSTOMERWMID':
                $customerwmid=$e['value'];
                break;
        };
    };
    return array($state,$customerwmid);
};

?>