<?php
/*
Модуль ведения логов
Автор: Denvas
*/
	$statinfo=counter();
    //==================================================//
    /*
    Счетчик
    */
    function counter($calc=1){
        global $path_logs, $stat_from, $stat_getparam, $title, $nextday, $stat_daysfrom, $partnersite, $user_agent;
		$maxhourlog=1;
		
        $user_agent=(isset($_SERVER['HTTP_USER_AGENT'])?htmlspecialchars($_SERVER['HTTP_USER_AGENT']):"");
        $ip=(isset($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:"");
        $referer=isset($_SERVER['HTTP_REFERER'])?strtolower($_SERVER['HTTP_REFERER']):"";
		$ipproxy=(!empty($_SERVER["HTTP_X_FORWARDED_FOR"]))?$_SERVER["HTTP_X_FORWARDED_FOR"]:"";
        //определение роботов
        $robots="";
        $_agentname=array(
            //поисковики
            array('Google',0,'google'),
            array('Yandex',0,'Yandex'),
            array('Rambler',0,'StackRambler'),
            array('MSN',0,'msnbot'),
            array('Aport',0,'Aport'),
            array('Yahoo',0,'help.yahoo.com'),
            //неизвестные роботы
            array('other robot',0,'http://'),    
        );
        $nagentname=count($_agentname);
        for($i=0;$i<$nagentname;$i++){
            if(strpos($user_agent,$_agentname[$i][2])!==false){
                $robots=$_agentname[$i][0];break;
            };
        };
		
        $nextday=0;//переход между сутками
        $namecounter=$path_logs."/counter.log";
        if(!empty($robots)){
            $namecounter=$path_logs."/counter_robots.log";
        };

        $fd_lock=fopen($path_logs."/counter.lock","wb");
        flock($fd_lock,LOCK_EX);
        $counter=@file_get_contents($namecounter);
        if(substr_count($counter,"|".$ip."|")>10)$calc=0;//слишком много запросов с одного IP. Скорее всего, это накрутка
        $counter=explode("\n",$counter);
        if(empty($counter[0]))$counter[0]=0;//время последнего обновления счетчика
        if(empty($counter[1]))$counter[1]=0;//уников всего
        if(empty($counter[2]))$counter[2]=0;//количество показов сегодня
        if(empty($counter[3]))$counter[3]=0;//уников сегодня
        if(empty($counter[4]))$counter[4]=0;//показов страниц сегодня
        if(empty($counter[5]))$counter[5]=0;//количество посетителей вчера
        $ctime=time();
        //переход между сутками
        if(($counter[0])&&(date("d",$counter[0])!=date("d",$ctime))){
            $nextday=1;//перешли на следущий день. поставим метку
            //записать статистику (только если это не робот)
            if(empty($robots)){
                $fd=fopen($path_logs."/stat.log","ab");
                fwrite($fd,date("Y-m-d", $counter[0])."|".$counter[2]."|".$counter[4]."|\n");
                fclose($fd);
            };//if(empty($robots))
            $counter[5]=$counter[2];
            $counter[2]=0;//сбросить уники
            $counter[4]=0;//сбросить хиты
        };
        $counter[3]++;$counter[4]++;
        $j=0;
        if(empty($memberinfo["login"])){
            $keys="|".$ip."|".$user_agent."|";
        }
        else{
            $keys=$memberinfo["login"]."|";
        };
        $online=0;$membersonline=0;
        $flag=0;$newuser=0;
        $nncounter=count($counter);
        for($j=6;$j<$nncounter;$j++){
            $elem=explode("|",$counter[$j]);
            if(strpos($counter[$j],$keys)===0){$flag=$j;}
            elseif($elem<3){array_splice($counter,$j,1);$j--;$nncounter--;}//удалить пустые строки
            elseif((int)$elem[3]+60*5>$ctime){$online++;if(!empty($elem[0]))$membersonline++;}//последнее обновление меньше чем 5 минут назад
            elseif((int)$elem[3]+60*60*$maxhourlog<$ctime){array_splice($counter,$j,1);$j--;$nncounter--;};//последнее обновление больше часа назад, вообще удалим
        };
        if(!$flag){
            $flag=count($counter);$newuser=1;
            $counter[1]++;$counter[2]++;
        }
        elseif($counter[2]<1)$counter[2]=1;
		
        $online++;
        if(!empty($memberinfo["login"]))$membersonline++;
        $counter[$flag]=(empty($memberinfo["login"])?"":$memberinfo["login"])."|".$ip."|".$user_agent."|".$ctime."|".QueryParam(array("sid","wv","tr",$stat_from),0,"","",0)."|".$title;

        $counter[0]=time();
        if($calc){
            $fd=@fopen($namecounter,"wb");
            if($fd){
                fwrite($fd,join("\n",$counter));
                fclose($fd);
            };
        };//if($calc)
        fclose($fd_lock);
        //занесение расширенной инфы
		if(($calc)&&(!empty($stat_getparam))&&(!empty($_GET[$stat_getparam]))){
            CounterExtInfo($path_logs."/stat_".$stat_getparam.".log",$_GET[$stat_getparam],array($newuser,1));
		};
        if(($calc)&&($newuser)){
            //подсчет реферов
            if(($referer)&&(strpos($referer,@$_SERVER['HTTP_HOST'])===false)&&(strpos($referer,"http")===0)){
				$parseref=parse_url($referer);
				if(isset($parseref["query"])){
					parse_str($parseref["query"],$query);
					$namefilelog=$path_logs."/stat_query".(!empty($stat_daysfrom)?("_".date("Y-m-d",time())):"").".log";
					if((strpos($referer,"google")!==false)&&(isset($query["q"])))
						CounterExtInfo($namefilelog,trim("google:".$query["q"]));
					elseif((strpos($referer,"yandex")!==false)&&(isset($query["text"])))
						CounterExtInfo($namefilelog,trim("yandex:".$query["text"]));
				};
                $referer=explode("?",$referer);//отрезать все по звездочку
                CounterExtInfo($path_logs."/stat_ref".(!empty($stat_daysfrom)?("_".date("Y-m-d",time())):"").".log",$referer[0]);
            }//if
			else{
				$referer="not";
			};

			//кусок партнерской программы по учету заходов
			if((empty($robots))&&($referer)&&(!empty($partnersite))&&(!empty($_GET["dir"]))){
				if(strpos($user_agent,"Opera Mini")!==false){
					$user_agent=$user_agent.(isset($_SERVER["HTTP_X_OPERAMINI_PHONE_UA"])?(" ".$_SERVER["HTTP_X_OPERAMINI_PHONE_UA"]):"");
				};
				$dirpath=isset($_GET["dir"])?$_GET["dir"]:"";
				$namepartners="partners/".strtr($dirpath,array("."=>"_","/"=>"_"));
				if(file_exists($namepartners)){
					$id_partners=explode("|",file_get_contents($namepartners));
					$id_partners[0]=(int)$id_partners[0];
					if(!empty($id_partners[0])){
						$nameclicks="partners/clicks_".$id_partners[0].".txt";
						if(file_exists($nameclicks))$dataclicks=file_get_contents($nameclicks); else $dataclicks="";
						$logclick="|".$ip."|".$user_agent."|".round(time()/60)."|";
						$nlines=substr_count($dataclicks,"\n");
						$operator=getoperatorGO($ip,$ipproxy);
						$uniq=0;
						//проверка на наличие куки
						if(!empty($_COOKIE["site"]))$uniq=1;
						//проверка на наличие клика
						if((!$uniq)&&(strpos($dataclicks,$logclick)!==false))$uniq=1;
						//проверка на ссылающиюся страницу
						$refcheck=explode("/",$id_partners[2]);$refcheck=$refcheck[2];
						if((!$uniq)&&(strcmp($referer,"not")!=0)&&(strpos($referer,$refcheck)===false)){
							$uniq=10;
						};
						//кликнули с тогоже IP что и подтверждение
						if((!$uniq)&&(strcmp($id_partners[3],$ip)==0)){
							$uniq=8;
						};
						//кликнули с тогоже браузера, что и подтверждение
						if((!$uniq)&&(strcmp($id_partners[4],$user_agent)==0)){
							$uniq=9;
						};
						//проверка на недавность клика с этого IP или браузера
				        if(!$uniq){
				            $len=strlen($dataclicks);
				            if(strpos($dataclicks,$user_agent."|")>$len-300)$uniq=6;
							elseif(strpos($dataclicks,$ip."|")>$len-300)$uniq=7;
				        };
						//проверка на операторов
						if(!$uniq){
							//проверка на определенность оператора
							if(strpos($operator,"other")!==false){
								$uniq=5;
							}
							//проверк на 30% операторов
							elseif($nlines>3){
								$nrep=substr_count($data,$oparator);
								if($nrep/$nlines>0.3)$uniq=4;
							};
						};//if(!$uniq)
						//проверка на привышение кликов с одного оператора
						if((!$uniq)&&($nlines>3)){
							//превышение кликов с одного IP
							if(!$uniq){
								$nrep=substr_count($data,$ip);
								if($nrep/$nlines>0.3)$uniq=2;
							};
							//превышение кликов с одного браузера
							if(!$uniq){
								$nrep=substr_count($data,$user_agent);
								if($nrep/$nlines>0.3)$uniq=3;
							};
							//превышение кликов с непереданным реферером
							if((!$uniq)&&(strcmp($referer,"not")==0)){
								$nrep=substr_count($data,"not");
								if($nrep/$nlines>0.5)$uniq=11;
							};
						};//if($nlines>3)
						if(!$uniq){
							$fileopt="ab";
							if($dataclicks){
								$time1=substr($dataclicks,0,strpos($dataclicks,"|"));
								if($time1<time()-24*60*60)$fileopt="wb";
							};
							setcookie("site",$id_partners[0],time()+3*24*60*60,"/");
							$ses=$id_partners[0].(time()%10000).mt_rand(100,999);
							$fd=fopen("partners/session/".$ses,"wb");
							fwrite($fd,$ip."|".$user_agent."\n".$nameclicks."\n".$fileopt."\n".time().$logclick.$operator."|".$referer."\n".$id_partners[0]."\n".$id_partners[1]);
							fclose($fd);
							//добавить картинку на страницу для ловли накрутчиков
							global $codeend;
							$codeend.="<img src='logsimg.php?check=".$ses."' alt='.'/>";
						}
						else{
							$fd=fopen($nameclicks.".bad",($nextday)?"wb":"ab");
							fwrite($fd,time().$logclick.$operator."|".$referer."|".$uniq."\n");
							fclose($fd);
						};
					};//if(!empty($id_partners[0]))
				};//if(file_exists($namepartners))
			};//if(($newuser)&&(!empty($partnersite)))
            //подсчет входов from
            if((!empty($stat_from))&&(!empty($_GET[$stat_from]))){
                $frompartner=trim($_GET[$stat_from]);
                CounterExtInfo($path_logs."/stat_from".(!empty($stat_daysfrom)?("_".date("Y-m-d",time())):"").".log",$frompartner);
            };//if
        };//if подсчет входов "откуда"
        //возврат данных
        return array("yesterdayuniq"=>$counter[5],"alluniq"=>$counter[1],"allhits"=>$counter[3],"todayuniq"=>$counter[2],"todayhits"=>$counter[4],"online"=>$online);
    };
    //==================================================//
    /*
    Занесение инфорамции по ключу param
    Используется для подсчета from и referer
    */
    function CounterExtInfo($namefile,$param,$extparam=array()){
        $from=$param."|";
        $flag=true;
        $statist=@file($namefile);$nstat=count($statist);
        //чистка устаревших данных
        if(mt_rand(0,100)==0){
            $timeold=time()-30*24*60*60;
            for($j=0;$j<$nstat;$j++){
                $elem=explode("|",trim($statist[$j]));
                if($elem[2]<$timeold){
                    array_splice($statist,$j,1);
                    $j--;$nstat--;
                };
            };//for
        };//if(mt_rand(0,100)==0)
        //изменение данных
		$nextparam=count($extparam);
        for($j=0;$j<$nstat;$j++){
            if(strpos($statist[$j],$from)===0){
                $elem=explode("|",trim($statist[$j]));
                $elem[1]++;
                $elem[2]=time();
                for($i=0;$i<$nextparam;$i++)
                    if(isset($elem[3+$i]))$elem[3+$i]=$elem[3+$i]+$extparam[$i]; else $elem[3+$i]=$extparam[$i];
                $statist[$j]=join("|",$elem)."\n";
                $flag=false;
                break;
            };//if
        };//for
        if($flag)$statist[]=$from."1|".time()."|".join("|",$extparam)."\n";
        $fd=@fopen($namefile,"wb");
        if($fd){flock($fd,LOCK_EX);fwrite($fd,join($statist));fclose($fd);};
    };//function CounterExtInfo($namefile,$param)
    //==================================================//
    function getoperatorGO($ip,$ipproxy=""){
        include("baseip.php");
        if(($ipproxy)&&((strpos($ip,"195.189.142.")===0)||(strpos($ip,"195.189.143.")===0)||(strpos($ip,"91.203.96.")===0))){
            $ipproxy=explode(",",$ipproxy);
            $ipcheck=IPnormal($ipproxy[0]);
            $pref="operamini:";
        }
        else{
            $ipcheck=IPnormal($ip);
            $pref="";
        };
        $nbase=count($dataip);
        for($i=0;$i<$nbase;$i++){
            $row=&$dataip[$i];
            if((strcmp($row[0],$ipcheck)<=0)&&(strcmp($row[1],$ipcheck)>=0))return $pref.$row[4];
        };
        return $pref."other";
    };
    //==================================================//

?>