DROP TABLE IF EXISTS advin;
create table advin
(
    id_advin int not null auto_increment,  #идентификатор
    url varchar(255) not null,            #название
    title varchar(255) not null,
    id_user int not null,
    startadv datetime,
    stopadv datetime,
	status enum('active','moderate','ban','done') default 'active',
	houradv int,
        primary key(id_advin),
        key(startadv),
        key(stopadv),
		key(status)
);
