<?php
/*
Генерация статистики системы
http://bmatrix.net/
*/
	$row=SQLrow("select max(id_user) as _users, sum(balance) as _balance, sum(balance_banners) as _balancebanners from users");
	$code="Статистика\n";
	//регистраций
	$code.='users:=='.$row["_users"]."\n";
	//денег
	$code.='balance:=='.round($row["_balance"])."\n";
	//кредитов
	$code.='credits:=='.round($row["_balancebanners"])."\n";
	
	//активных пользователей
	$code.='usersactive:=='.SQLone("select count(id_user) as _users from users where status='active' and (banners_todayshow+banners_yesterdayshow+moneyyesterday+moneytoday+moneyadvyesterday+moneyadvtoday>0)")."\n";
	$code.='usersban:=='.SQLone("select count(id_user) as _users from users where status='ban'")."\n";
	//новых пользователей
    $code.="usersnew:==".SQLone("select count(id_user) from users where status='active' and regdate>'".date("Y-m-d H:i:s", time()-24*60*60)."'")."\n";
	//баннеров
	$code.="banners:==".SQLone("select count(*) from banners")."\n";
	//включенных баннеров
	$code.="bannersactive:==".SQLone("select count(*) from banners where status='active'")."\n";
	//показов сегодня
    $code.="showtoday:==".SQLone("select sum(bshow) from banners")."\n";
	//кликов сегодня
    $code.="clicktoday:==".SQLone("select sum(bclick) from banners")."\n";
	//показов вчера
    $code.="showyesterday:==".SQLone("select sum(btodayshow) from banners")."\n";
	//кликов вчера
    $code.="clickyesterday:==".SQLone("select sum(btodayclick) from banners")."\n";
	//показов всего
    $code.="showall:==".SQLone("select sum(ballshow) from banners")."\n";
	//кликов всего
    $code.="clickall:==".SQLone("select sum(ballclick) from banners")."\n";
	//ctr
    $code.="ctrday:==".(float)SQLone("select round(sum(bclick)/sum(bshow)*100,2) from banners")."\n";
    $code.="ctryesterday:==".(float)SQLone("select round(sum(btodayclick)/sum(btodayshow)*100,2) from banners")."\n";
    $code.="ctrall:==".(float)SQLone("select round(sum(ballclick)/sum(ballshow)*100,2) from banners")."\n";
	//биржа
	$data=SQLrow("select sum(balance), round(sum(balance*price),2), count(*) from exchange_money where status='active'",MYSQL_NUM);
	if(empty($data[0]))$data=array(0,0,0);
	$code.="exchange_sellcount:==".$data[2]."\n";
	$code.="exchange_credit:==".$data[0]."\n";
	$data2=SQLrow("select count(*), round(sum(amount),2) from transbalance where typet='exchange' and datecreate>='".date("Y-m-d", time())."'",MYSQL_NUM);
	if(empty($data2[0]))$data2=array(0,0,0);
	$data=SQLrow("select count(*), round(sum(amount),2) from transactions where typetrans='exchange' and way='in' and transdate>='".date("Y-m-d", time())."'",MYSQL_NUM);
	if(empty($data[0]))$data=array(0,0,0);
	$code.="exchange_todaycreditbuy:==".$data2[1]."\nexchange_todaybalancebuy:==".$data[1]."\nexchange_todaycountbuy:==".$data[0]."\n";
	$code.=$template["separator"];
	$data2=SQLrow("select count(*), round(sum(amount),2) from transbalance where typet='exchange' and DATE_FORMAT(datecreate,'%Y-%m-%d')=DATE_FORMAT(DATE_ADD(NOW(), INTERVAL -1 day),'%Y-%m-%d')",MYSQL_NUM);
	if(empty($data2[0]))$data2=array(0,0,0);
	$data=SQLrow("select count(*), round(sum(amount),2) from transactions where typetrans='exchange' and way='in' and DATE_FORMAT(transdate,'%Y-%m-%d')=DATE_FORMAT(DATE_ADD(NOW(), INTERVAL -1 day),'%Y-%m-%d')",MYSQL_NUM);
	if(empty($data[0]))$data=array(0,0,0);
	$code.="exchange_yesterdaycreditbuy:==".$data2[1]."\nexchange_yesterdaybalancebuy:==".$data[1]."\n";
	
	$fd=fopen("data/statistbanners.txt","wb");
	fwrite($fd,$code);
	fclose($fd);
	
	$code="Рейтинг wap-мастеров\n";
	$result=SQLquery("select id_user, banners_todayshow, banners_todayclick, site from users where status='active' and banners_todayshow>0 order by banners_todayshow desc limit 0,1000");
	$rows=mysql_num_rows($result);
	for($i=0;$i<$rows;$i++){
		$row=mysql_fetch_array($result,MYSQL_ASSOC);
		$code.="ID:".$row["id_user"].($row["site"]?(" (<a href='go.php?url=http://".urlencode($row["site"])."'>".$row["site"]."</a>)"):"").", показов: ".$row["banners_todayshow"].", кликов: ".$row["banners_todayclick"].", CTR: ".round($row["banners_todayclick"]/$row["banners_todayshow"]*100,2)."\n";
	};
	$fd=fopen("data/statistbannersusers.txt","wb");
	fwrite($fd,$code);
	fclose($fd);
	
	$code="Реферальский рейтинг\n";
	$result=SQLquery("select id_parent, count(id_user) as _c from users where status='active' group by id_parent order by _c desc limit 0,1000");
	$rows=mysql_num_rows($result);
	for($i=0;$i<$rows;$i++){
		$row=mysql_fetch_array($result,MYSQL_ASSOC);
		if(empty($row["id_parent"]))continue;
		$code.="ID:".$row["id_parent"]." рефералов:".$row["_c"]."\n";
	};
	$fd=fopen("data/statistbannersusersref.txt","wb");
	fwrite($fd,$code);
	fclose($fd);
	
	$code="Рейтинг баннеров\n";
	$result=SQLquery("select id_banner, bshow, bclick, id_user, ext from banners where status='active' order by bshow desc limit 0,1000");
	$rows=mysql_num_rows($result);
	for($i=0;$i<$rows;$i++){
		$row=mysql_fetch_array($result,MYSQL_ASSOC);
		$code.="ID:".$row["id_banner"]."<br/>Показов сегодня: ".$row["bshow"]."<br/>CTR:".($row["bshow"]?round($row["bclick"]/$row["bshow"]*100,2):0)."<br/><img src='banners_view.php?id=".$row["id_banner"].".".$row["ext"]."' alt=''/>\n";
	};
	$fd=fopen("data/statistbannersctr.txt","wb");
	fwrite($fd,$code);
	fclose($fd);
?>