DROP TABLE IF EXISTS flow;
create table flow
(
    id_flow int not null auto_increment,
	id_user int default 0,
    name varchar(255) not null,
	description text,
	
    flag_client int default 0,
    flag_agent int default 0,
    flag_ip int default 0,
    flag_page int default 0,
    flag_lang int default 0,
    flag_hour int default 0,
    flag_user int default 0,
    flag_operator int default 0,
	flag_weekday int default 0,

    flt_client text default '',
    flt_agent text default '',
    flt_ip text default '',
    flt_page text default '',
    flt_lang varchar(255) default '',
    flt_hour varchar(255) default '',
    flt_user text default '',
    flt_operator text default '',
	flt_weekday text default '',
	
        primary key(id_flow)
);

insert into flow set id_user=0, id_flow=100, flag_client=1, flt_client='opera;cellxhtml;cellwml', name='Весь wap', description='Сотовые xhtml и wml + opera mini';
insert into flow set id_user=0, id_flow=99, flag_client=1, flt_client='cellxhtml', name='XHTML браузеры', description='Сотовые с поддержкой XHTML mobile';
insert into flow set id_user=0, id_flow=98, flag_client=1, flt_client='cellwml', name='WML браузеры', description='Старые сотовые с поддержкой только WML';
insert into flow set id_user=0, id_flow=97, flag_client=1, flt_client='comp', name='Компьютеры', description='Только компьютеры под управлением операционной системы Windows';
