DROP TABLE IF EXISTS lottery;
create table lottery
(
    id_lottery int not null auto_increment,  
    status enum('make','active','ban','done') default 'make',
	name varchar(255) not null,
    datestart date,
	datestop date,
	description text,
	id_userwin int default 0,
	priceticket float default 0,
	balance float default 0,
		primary key(id_lottery),
		key(status),
		key(datestart),
		key(datestop)
);

DROP TABLE IF EXISTS lottery_ticket;
create table lottery_ticket
(
    id_lottery int not null,  
	id_user int not null,
	id_ticket bigint not null,
	datebuy datetime,
	price float default 0,
		key(id_lottery),
		key(id_user),
		key(id_ticket)
);
