alter table users add modquest text;

DROP TABLE IF EXISTS quest_topic;
create table quest_topic
(
    id_topic int not null auto_increment,  #идентификатор
    name varchar(255) not null,            #название
    description text,
    price float not null,
    id_user int not null,
    status enum('make','moderate','active','hidden','ban') default 'make',
	banrules int default 0,
    typet enum('test','quest','voting') not null,
    datesend datetime,
	url varchar(255) default '',
	answergood int default 0,
	answerbad int default 0,
	id_moder int default 0,
	admindesc text default '',
	
        primary key(id_topic),
        key(id_user),
        key(status)
);

DROP TABLE IF EXISTS quest_post;
create table quest_post
(
    id_post int not null auto_increment,  #идентификатор
    id_topic int not null,
    pos int default 0,
    quest varchar(255) not null,            #вопрос
    answer1 varchar(255) default '',        #ответ
    answer2 varchar(255) default '',        #ответ
    answer3 varchar(255) default '',        #ответ
    answer4 varchar(255) default '',        #ответ
    answer5 varchar(255) default '',        #ответ
    answer6 varchar(255) default '',        #ответ

    goodanswer int not null,

        primary key(id_post),
        key(id_topic),
        key(pos)
);

DROP TABLE IF EXISTS quest_statist;
create table quest_statist
(
    id_post int not null,  #идентификатор
    id_topic int not null,
    answer1 int default 0,        #ответ
    answer2 int default 0,        #ответ
    answer3 int default 0,        #ответ
    answer4 int default 0,        #ответ
    answer5 int default 0,        #ответ
    answer6 int default 0,        #ответ

        unique(id_post),
        key(id_topic)
);
