alter table users add modtaskpay int default 0, add modtaskpaymoney float default 0;

DROP TABLE IF EXISTS task;
create table task
(
    id_task int NOT NULL auto_increment,                  
    status enum('moderate','active','done','ban','break') default 'moderate',
	banrules int default 0,
	dateend datetime default '0000-00-00',
    price float default 0,
    id_user int not null,
    datecreate datetime not null,
    title varchar(255) not null,
    description text,
	startdesc text,
	num int default 1,
	id_moder int default 0,
	admindesc text default '',
	
       primary key (id_task),
       key(status),
       key(id_user),
       key(datecreate)
);

DROP TABLE IF EXISTS task_solution;
create table task_solution
(
    id_solution int NOT NULL auto_increment,                  
    id_task int not null,
    id_user int not null,
    datecreate datetime not null,
    message text,
	status enum('private','public','ban') default 'public',
       primary key (id_solution),
       key(id_task),
       key(id_user)
);
