alter table users add balance_traffruletka float default 0, add traffrul_clickyesterday int default 0;

DROP TABLE IF EXISTS traffrul_links;
create table traffrul_links
(
    id_link int NOT NULL auto_increment,                  
    url varchar(255) not null,                #рекламируемый сайт
    name varchar(255) default '',
    status enum('hidden','active','delete','moderate','ban') default 'moderate', #статуст кампании
	banrules int default 0,
    id_user int not null default 0,           #кому пренадлежит ссылка
    counter int not null default 0,           #счетчик переходов
    counterday int not null default 0,        #количество кликов в текущий день
    admindesc text default '',                #комментарий
	id_moder int default 0,
    editdate datetime default '0000-00-00',   #дата регистрации
       primary key (id_link),
       key(status),
       key(id_user)
);

DROP TABLE IF EXISTS traffrul_stake;
create table traffrul_stake
(
    id_stake int NOT NULL auto_increment,                  
    id_user int not null default 0,           #кому пренадлежит ссылка
	numstake int not null default 0,
    stakedate datetime default '0000-00-00',   #дата ставки
       primary key (id_stake),
       key(id_user)
);
