<?php
/*
JS страница с рекламными ссылками
принимает get параметры
uid - идентификатор пользователя
q - фраза поиска (utf)
Проект zadanie.biz
Автор: Denvas
http://bmatrix.net/
*/
	require_once("config.php");
    require_once("config_modules.php");
	require_once("modules/flow/function.php");
	include_once("core/functionsql.php");

	header("Content-type: text/html; charset=utf-8");
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); //Дата в прошлом
	header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
	header("Pragma: no-cache"); // HTTP/1.0
	header("Last-Modified: ".date("r", time()));//обновлено сейчас
    
	global $global_flow;
	$global_flow=array();
	$code="";
	$ctime=time();
	if(empty($_GET["uid"]))NotADVerror(0);
	$uid=isset($_GET["uid"])?(int)$_GET["uid"]:1;
	$t=time();
	
	//папки, где хранится инфа о пользователе
	$pathname="users/".(500*(int)($uid/500))."/".$uid."/";
	if(!file_exists($pathname."clicks.php"))NotADVerror(1);
	require_once($pathname."clicks.php");
	
	if(!empty($_GET["q"])){
		$search=trim($_GET["q"]);
		$ifoa="or";
		$where="1=2";                
		$searcha=strtr($search,array(","=>" ",";"=>" ","."=>" ","!"=>" "));
		$searcha=mylower($search);
		$arr=explode(" ",$searcha);		
		$narr=count($arr);
		$k=0;
		for($i=0;$i<$narr;$i++){
			$s=trim($arr[$i]);
			if(strlen($s)<3)continue;
			if(isset($clicks_skipwords[$s]))continue;//слово в запрещенных или неважных
			$where.=" ".$ifoa." ( keywords like '% ".AddSlashes($s)."%')";
			$k++;if($k>3)break;
		};//for
	}
	else{
		$where="1=1";                
	};
	
	
	//выборка рекламы

	$nametemp="temp/expclick2_".$uid."_".md5($where).".tmp";
	if(file_exists($nametemp)){
		$content=file_get_contents($nametemp);
		$oldtime=(int)substr($content,0,strpos($content,"\n"));
	} else $oldtime=0;

	if(time()-$oldtime>3*60){
		$newadv=array();
		$correctday=((int)date("H")*60+date("i"))/(24*60);
		SQLconnect();
	    $advdata=SQLarray("select id_user, id_link, url, balance, counterbalance, maxday, counterday, price, name, id_flow, description from clicks_links where status='active' and (maxday=0 or counterday<maxday*".$correctday.") and (".$where.") order by price desc limit 0,200",MYSQL_ASSOC);
		$ndata=count($advdata);
		if($ndata){
			for($i=0;$i<$ndata;$i++){
				$row=$advdata[$i];
				if(empty($row["name"]))continue;
				//превышен максимальный баланс
				if($row["balance"]<$row["price"]){
					SQLquery("update clicks_links set status='hidden' where id_link=".$row["id_link"]);
					continue;
				};
				//фильтры
				if($row["id_flow"]){
					if(empty($global_flow[$row["id_flow"]])){
						$global_flow[$row["id_flow"]]=SQLrow("select * from flow where id_flow=".$row["id_flow"]);
					};
				};
				$url="http://".$maindomain."/clicks.php?check=".md5($uid.$t.$row["id_link"].$antifraud_key)."p&amp;t=".$t."&amp;uid=".$uid."&amp;go=".$row["id_link"];
				$newadv[]=array($row["id_link"],$row["price"],$row["id_flow"],$row["name"],$row["description"],$url,$row["url"]);
			};//for($i=0;$i<$ndata;$i++)
		};//if($ndata)		
		SQLclose();
		$advdata=$newadv;$ndata=count($advdata);
		$fd=fopen($nametemp,"wb");
		fwrite($fd,$t."\n".serialize($advdata)."\n".serialize($global_flow));
		fclose($fd);
	}//if(time()-$oldtime>3*60)
	else{
		$data=explode("\n",$content);
		$t=$data[0];$advdata=unserialize($data[1]);$ndata=count($advdata);
		$global_flow=unserialize($data[2]);
	};//else
	
	$code.=$ndata."\n";
	$code.=$t."\n";
	$code.=serialize($advdata)."\n";
	$code.=serialize($global_flow)."\n";
	$code.="&#x2191; Реклама от <a href='http://".$maindomain."/?uid=".$uid."'>zadanie.biz</a>\n";
	print $code;
    //==================================================//
	function NotADVerror($err=0){
		global $uid, $maindomain;
		print "0\n";
		print time()."\n";
		print serialize(array(array(0,0,0,"Раскрутка сайтов","Все виды раскрутки: покупка трафика, прямые ссылки, задания","http://".$maindomain."/?uid=".$uid)))."\n";
		print serialize(array())."\n";
		print "&#x2191; Реклама от <a href='http://".$maindomain."/?uid=".$uid."'>zadanie.biz</a>\n";
		exit;
	};
?>