<?php
/*
Преобразование картинки под нужный размер
Автор: Denvas
*/
    $pic=$_GET["pic"];
    $w=(int)$_GET["w"];if($w<64)$w=64;if($w>1024)$w=1024;
    $h=(int)$_GET["h"];if($h<64)$h=64;if($h>1024)$h=1024;
	$resize_type=isset($_GET["t"])?$_GET["t"]:0;
    //защита от выхода в другие каталоги и запрос из текущего
    if(strpos($pic,"..")!==false)exit;
    if(strpos($pic,"/")===false)exit;
	require_once("config.php");
//==================================================//
    //закешировать картинку
    header("Cache-control: public");
    header("Cache-control: max-age=".(24*60*60));
    header("Content-type: image/jpeg");
    //вывести картинку на экран
    ResizeImage($path_data."/".$pic,"",$w,$h,$resize_type);
//==================================================//
    /*
    Изменить размер картинки
    */
    function ResizeImage($filein,$fileout,$maxwidth=0,$maxheight=0,$type=0){
        global $resize_type;
        if(!file_exists($filein))return 2;
        $size=getimagesize($filein);
        if(!$size)return 3;
        $s_width=$size[0];
        $s_height=$size[1];
        if(stristr($filein,".jpg")){
            $im_in = @imagecreatefromjpeg($filein);
            $extorig="jpg";
        }
        elseif(stristr($filein,".gif")){
            $im_in = @imagecreatefromgif($filein);
            $extorig="gif";
        }
        elseif(stristr($filein,".png")){
            $im_in = @imagecreatefrompng($filein);
            $extorig="png";
        }
        else return 4;
        if(!$im_in)return 5;

        if($maxwidth!=0)$dx=$s_width/$maxwidth; else $dx=0;
        if($maxheight!=0)$dy=$s_height/$maxheight; else $dy=0;
        if($dx>$dy)$dd=$dx; else $dd=$dy;
        $dstX=0;$dstY=0;$srcX=0;$srcY=0;
        $type=(int)$type;
        //без изменения размера
        if(($maxwidth==0)&&($maxheight==0)){
            $d_width=$s_width;
            $d_height=$s_height;
        }
        //сохранение пропорций
        elseif($type==0){
            $d_width=round($s_width/$dd);
            $d_height=round($s_height/$dd);
        }
        //изменение размера без сохранения пропорций
        elseif($type==1){
            if($maxwidth!=0)$d_width=$maxwidth; else $d_width=round($s_width/$dd);
            if($maxheight!=0)$d_height=$maxheight; else $d_height=round($s_height/$dd);  
        }
        //вырезание куска, а потом изменение размера для сохранения пропорций
        elseif($type>1){
            if($dx<$dy)$dd=$dx; else $dd=$dy;
            //окончательный размер
            $d_width=$maxwidth;
            $d_height=$maxheight;
            //корректировка исходного размера
            $s_w=round($d_width*$dd);
            $s_h=round($d_height*$dd);
            //вырезать центр
            if($type==2){
                $srcX=($s_width-$s_w)>>1;$srcY=($s_height-$s_h)>>1;
            }
            //вырезать слева сверху
            elseif($type==3){
                $srcX=0;$srcY=0;
            }
            //вырезать справа снизу
            elseif($type==4){
                $srcX=$s_width-$s_w;$srcY=$s_height-$s_h;
            };
            $s_width=$s_w;
            $s_height=$s_h;
        };//elseif($type>1)
        //создание новой картинки
        $im_out = imagecreatetruecolor($d_width, $d_height);
        imagefill($im_out, 0, 0, 16777215);//залить белым
        //копирование картинки
        ImageCopyResized($im_out, $im_in, $dstX, $dstY, $srcX, $srcY, $d_width, $d_height, $s_width, $s_height);
        //сохранение
        imagejpeg($im_out,$fileout,75);    
        return 0;
    };

?>