<?php
/*
Запуск по таймеру раз в несколько минут для обновления аукционов
Автор: Denvas
*/
    if(!extension_loaded('curl')) {
        if(!dl('curl.so')){print "Not load curl\n";exit;};
    };
    if(!extension_loaded('mysql')) {
        if(!dl('mysql.so')){print "Not load mysql\n";exit;};
    };
	
	$timefinal=3*60;//за 3 минуты до конца
	
    chdir(dirname(__FILE__)."/..");
    include_once("config.php");//путь до конфигурационного файла
    include_once("core/functionsql.php");
    include_once("core/money.php");
    include_once("config_modules.php");
	$pid=getmypid();	
    $fd_lock=fopen("temp/shop_auctionscan.lock","w");
    if(!flock($fd_lock,LOCK_EX|LOCK_NB)){print "Locked\n";exit;};
    fwrite($fd_lock,time()."\n".$pid."\n");
	$starttime=time();
    @set_time_limit(0);//выполнять без ограничений
	
    SQLconnect();
	
	do{
		$flagreplace=0;
		$ct=time();
		$data=SQLarray("select id_auction, endtime, id_enduser, autostake, price, stepprice, steptime, id_product, discount100, fixprice, backmoney, startstake from shop_auction where status='active' and endtime<".($ct+$timefinal),MYSQL_ASSOC);
		$ndata=count($data);
		for($j=0;$j<$ndata;$j++){
			$row=&$data[$j];
			//аукцион завершен
			if($row["endtime"]<$ct){				
				print "End auction: ".$row["id_auction"]."\n";
				$pricesell=$row["price"];
				if($row["discount100"]==1)$pricesell=0;
				elseif($row["discount100"]==2)$pricesell=$row["fixprice"];
				SQLquery("update shop_auction set stopdate=NOW(), status='done', statusproduct='win', pricesell=".$pricesell." where id_auction=".$row["id_auction"]);
				$infoproduct=SQLrow("select sell, minprice, maxprice from shop_product where id_product=".$row["id_product"]);
				$query="sell=sell+1";
				if($infoproduct["sell"]==0)$query.=", minprice=".$pricesell.", maxprice=".$pricesell;
				else{
					if($pricesell<$infoproduct["minprice"])$query.=", minprice=".$pricesell;
					if($pricesell>$infoproduct["maxprice"])$query.=", maxprice=".$pricesell;
				};
				SQLquery("update shop_product set ".$query." where id_product=".$row["id_product"]);
				SQLquery("update users set winstake=winstake+1 where id_user=".$row["id_enduser"]);
				//SQLquery("delete from shop_autostake where id_auction=".$row["id_auction"]);//пока не удалять
				//возвратный аукцион
				if($row["backmoney"]){
					//вернуть ставки
					$namefile="data/shop/".$row["id_auction"]."/stake.txt";
					$backmoney=file($namefile);
					$n=count($backmoney);
					for($i=0;$i<$n;$i++){
						$r=explode("|",$backmoney[$i]);
						if($r[1]==$row["id_enduser"])continue;
						print "Vozvrat: ".$r[1]."\n";
						SQLquery("update users set balance_stake=balance_stake+1 where id_user=".$r[1]);
					};
				};//if($row["backmoney"])
			}
			//аукцион еще не завершен. нужно проверить автоставки
			elseif($row["autostake"]>0){
				$namefile="data/shop/".$row["id_auction"]."/stake.txt";
				$fd_lock1=fopen($namefile.".lock","wb");
				flock($fd_lock1,LOCK_EX);
				print "!";
				$userstake=array();
				SQLquery("delete from shop_autostake where id_auction=".$row["id_auction"]." and stopprice<".$row["price"]);
				$auto=SQLarray("select id_user, id_autostake from shop_autostake where id_auction=".$row["id_auction"]." and startprice<=".$row["price"]." and stopprice>=".$row["price"]." and maxstake>0");
				$n=count($auto);
				print "Auto stake: ".$row["id_auction"]." (".$n.")\n";
				for($i=0;$i<$n;$i++){
					$w=$auto[$i];
					print "Stake: ".$w[0]."\n";
					//последняя ставка от этого человека
					if($w[0]==$row["id_enduser"]){
						print "No. End user\n";
						continue;
					};
					//уже была ставка в данный такт
					if(isset($userstake[$w[0]])){
						print "No. Double stake\n";
						continue;
					};
					//занести пользователя
					$userstake[$w[0]]=1;
					//количество свободных ставок
					$balance_stake=SQLone("select balance_stake from users where id_user=".$w[0]);
					if($balance_stake<1){
						print "No. balance_stake=0\n";
						continue;
					};
					$fd=fopen($namefile,"ab");
					if($fd){
						print "YES. ".$w[0]."\n";
						$str=time()."|".$w[0]."|1|".($row["price"]+$row["stepprice"])."|".($row["endtime"]-time())."|\n";
						$c=fwrite($fd,$str);
						fclose($fd);
						$row["price"]+=$row["stepprice"];
						SQLquery("update users set balance_stake=balance_stake-1 where id_user=".$w[0]);
						SQLquery("update shop_auction set price=price+".$row["stepprice"].", endtime=endtime+".$row["steptime"].", countstake=countstake+1, id_enduser=".$w[0]." where id_auction=".$row["id_auction"]);
						SQLquery("update shop_autostake set maxstake=maxstake-1 where id_autostake=".$w[1]);
						$row["endtime"]+=$row["steptime"];
					}//if($fd)
					else{
						print "No. ERROR save file\n";
					};
				};//for($i=0;$i<$n;$i++)
				fclose($fd_lock1);
			};//elseif($row["autostake"]>0)
			//если до окончания какогото аукциона больше не будет запусков, то нужно запускать в текущем такте
			if($row["endtime"]-$timefinal>time())$flagreplace=1;
		};//for($j=0;$j<$ndata;$j++)
		sleep(1);
		if($flagreplace)print "Sleep ".time()."\n";
	}while($flagreplace);
	
    SQLclose();
	
    fclose($fd_lock);
    if(!empty($data))print "Ok\n";
?>