<?php
/*
Работа с дизайном
Автор: Denvas
http://bmatrix.net/
*/
    //шаблон
    global $template;
    //==================================================//
    /*
    Инициализация шаблонов
    */
    function InitDesign($name,$wapver,$fatal=true){
        global $path_template,$nrowpage;
        $content=@file($path_template."/".$name.$wapver.".txt");
        if(empty($content))
            if($fatal)NotFound("Not design ".$name.$wapver); else return array();
        $elem=explode("|",$content[0]);
        if(!empty($elem[1]))$nrowpage=(int)$elem[1];
        $ncontent=count($content);
        for($j=1;$j<$ncontent;$j++){
            $line=trim($content[$j]);
            if(empty($line))continue;
            $pos=strpos($line,":==");
            if($pos===false){
                $template[$name].=$line;
                continue;
            };
            $name=substr($line,0,$pos);
            $value=substr($line,$pos+3);
            $template[$name]=$value;
        };//for
        return $template;
    };
    //==================================================//
    /*
    Простой дизайн. более сложные реализуются индивидуально
    $str - основные данные, они будут вставлены в %code%
    $tpl - название шаблона
    $repl - дополнительные массив замены переменных
    */
    function design($str,$tpl="title",$repl=array()){
        global $template, $titlepage;
        if(!$str)return "";
		if(strcmp($tpl,"header")==0)$titlepage=$str;
        $repl[TMPL."class".TMPL]=$tpl;
        $repl[TMPL."code".TMPL]=$str;
        return strtr(isset($template[$tpl])?$template[$tpl]:$template["span"],$repl);
    };
    //==================================================//
?>