<?php
//==================================================//
    /*
      
    */
    function ResizeImage($filein,$fileout,$maxwidth=0,$maxheight=0,$type=0,$logo="",$logo_pos="0,0"){
        if(!file_exists($filein))return 2;
        $size=getimagesize($filein);
        if(!$size)return 3;
        $s_width=$size[0];
        $s_height=$size[1];
		$infopic=getimagesize($filein);
		if(empty($infopic))return 4;// 
        if(stristr($infopic["mime"],"jpeg")){
            $im_in = @imagecreatefromjpeg($filein);
            $extorig="jpg";
        }
        elseif(stristr($infopic["mime"],"gif")){
            $im_in = @imagecreatefromgif($filein);
            $extorig="gif";
        }
        elseif(stristr($infopic["mime"],"png")){
            $im_in = @imagecreatefrompng($filein);
            $extorig="png";
        }
        else return 4;
        if(!$im_in)return 5;

        if($maxwidth!=0)$dx=$s_width/$maxwidth; else $dx=0;
        if($maxheight!=0)$dy=$s_height/$maxheight; else $dy=0;
        if($dx>$dy)$dd=$dx; else $dd=$dy;
        $dstX=0;$dstY=0;$srcX=0;$srcY=0;
        $type=(int)$type;
        //  
        if(($maxwidth==0)&&($maxheight==0)){
            $d_width=$s_width;
            $d_height=$s_height;
        }
        // 
        elseif($type==0){
            $d_width=round($s_width/$dd);
            $d_height=round($s_height/$dd);
        }
        //    
        elseif($type==1){
            if($maxwidth!=0)$d_width=$maxwidth; else $d_width=round($s_width/$dd);
            if($maxheight!=0)$d_height=$maxheight; else $d_height=round($s_height/$dd);  
        }
        // ,       
        elseif($type>1){
            if($dx<$dy)$dd=$dx; else $dd=$dy;
            // 
            $d_width=$maxwidth;
            $d_height=$maxheight;
            //  
            $s_w=round($d_width*$dd);
            $s_h=round($d_height*$dd);
            // 
            if($type==2){
                $srcX=($s_width-$s_w)>>1;$srcY=($s_height-$s_h)>>1;
            }
            //  
            elseif($type==3){
                $srcX=0;$srcY=0;
            }
            //  
            elseif($type==4){
                $srcX=$s_width-$s_w;$srcY=$s_height-$s_h;
            };
            $s_width=$s_w;
            $s_height=$s_h;
        };//elseif($type>1)
        //  
        $im_out = imagecreatetruecolor($d_width, $d_height);
        imagefill($im_out, 0, 0, 16777215);// 
        // 
        ImageCopyResized($im_out, $im_in, $dstX, $dstY, $srcX, $srcY, $d_width, $d_height, $s_width, $s_height);
        //  
        if(!empty($logo)){
            if(strpos($logo,".png")!==false)
                $im_logo = @imagecreatefrompng($logo);
            elseif(strpos($logo,".gif")!==false)
                $im_logo = @imagecreatefromgif($logo);
            if($im_logo){
                $logo_w=imagesx($im_logo);
                $logo_h=imagesy($im_logo);
                $posl=explode(",",$logo_pos);
                $posl[0]=(int)$posl[0];
                
                if($posl[0]==-1)$x=0;
                elseif($posl[0]==0)$x=($d_width-$logo_w)>>1;
                elseif($posl[0]==1)$x=$d_width-$logo_w;
            
                if(empty($posl[1]))$posl[1]=0; else $posl[1]=(int)$posl[1];
                if($posl[1]==-1)$y=0;
                elseif($posl[1]==0)$y=($d_height-$logo_h)>>1;
                elseif($posl[1]==1)$y=$d_height-$logo_h;
                imagecopy($im_out,$im_logo,$x,$y,0,0,$logo_w,$logo_h);
            };//if($im_logo)
        };//if(!empty($resize_logo))
        //
        imagejpeg($im_out,$fileout,75);    
        if(strpos($fileout,".png")!==false)imagepng($im_out,$fileout);
        elseif(strpos($fileout,".gif")!==false)imagegif($im_out,$fileout);    
        elseif(strpos($fileout,".jpg")!==false)imagejpeg($im_out,$fileout,75);    
        return 0;
    };
?>