<?php
/*
Функции работы с деньгами
Автор: Denvas
http://bmatrix.net/
*/
    //==================================================//
    /*
    Снятие и начисление денег с учетом реферальского процента
    */
    function TransService($id_from,$id_to,$amount,$description,$perc=0,$savetrans=1,$advlogs=0,$typetrans='trans'){
        global $percdeeppartner, $moneydetail;
		if($amount>1)SaveLog("modeytrans",$id_from."|".$id_to."|".$amount."|".$description."|".$perc);//записывать все переводы больше 1 рубля
        $frominfo=SQLrow("select * from users where id_user=".$id_from);
        if(empty($frominfo))return false;
        //снять деньги
        if($perc>0)$amountfrom=$amount; else $amountfrom=round($amount*(1-$perc),4);
		$newbalance=$frominfo["balance"]-$amountfrom;
        if(($moneydetail)&&($savetrans)){
			SQLquery("insert into transactions set newbalance=".$newbalance.", transdate=NOW(), typetrans='".AddSlashes($typetrans)."', way='out', description='".AddSlashes($description)."', amount=".$amountfrom.", id_from=".$id_from.", id_to=".$id_to);
		};
		$query="";
		if($frominfo["minbalance"]>$newbalance)$query.=", minbalance=".(($newbalance>0)?$newbalance:0);
        SQLquery("update users set balance=balance-".$amountfrom.$query.($advlogs?(", moneyadvall=moneyadvall+".$amountfrom.", moneyadvtoday=moneyadvtoday+".$amountfrom):"")." where id_user=".$id_from);
        //начислить деньги получателю
        if($perc>0)$amountto=round($amount*(1-$perc),4); else $amountto=$amount;
        if(($moneydetail)&&($savetrans)){
			$newbalance=SQLone("select balance from users where id_user=".$id_to,0)+$amountto;
			SQLquery("insert into transactions set newbalance=".$newbalance.", transdate=NOW(), typetrans='".AddSlashes($typetrans)."', way='in', description='".AddSlashes($description)."', amount=".$amountto.", id_from=".$id_from.", id_to=".$id_to);
		};
        SQLquery("update users set balance=balance+".$amountto.($advlogs?(", moneyall=moneyall+".$amountto.", moneytoday=moneytoday+".$amountto):"")." where id_user=".$id_to);
        $moneyadmin=round($amount*abs($perc),3);//то, что осталось от перевода, т.е заработок администрации
        SystemMoney($id_from,$moneyadmin);
        return true;
    };//function TransService
    //==================================================//
    /*
    Начисление реферальских процентов
    */
    function TransRefer($id_from,$amount,$description){
        global $percdeeppartner,$moneydetail;
        $frominfo=SQLrow("select * from users where id_user=".$id_from);
        if(empty($frominfo))return false;
        $moneyadmin=0;
        //начисление реферальских
        if($frominfo["parentdeep"]){
            $moneypartner=$amount;
            $deep=explode(",",$frominfo["parentdeep"]);
            $ndeep=count($percdeeppartner);
            if($ndeep>count($deep))$ndeep=count($deep);
            for($i=0;$i<$ndeep;$i++){
                //партнерское вознаграждение
                $paypartner=round($moneypartner*$percdeeppartner[$i],3);
                if($paypartner<0.01)break;
                //от админского заработка отнять реферальские проценты
                $moneyadmin-=$paypartner;
                //обновить базу
                SQLquery("update users set balance=balance+".$paypartner.", moneyrefall=moneyrefall+".$paypartner." where id_user=".$deep[$i]);
                if($moneydetail)SQLquery("insert into transactions set typetrans='ref', way='in', transdate=NOW(), description='".AddSlashes("Deep ".($i+1).": ".$description)."', amount=amount+".$paypartner.", id_from=".$id_from.", id_to=".$deep[$i]."");
            };//for
        };//if($frominfo["parentdeep"])
        SystemMoney($id_from,$moneyadmin);
    };//function TransRefer
    //==================================================//
    /*
    Функция подсчета доходности системы
    */
    function SystemMoney($id_from,$money){
        if(abs($money)<0.001)return false;
        SQLquery("insert into systemmoney set day=NOW(), money=".$money." ON DUPLICATE KEY UPDATE money=money+".$money);
        SQLquery("update users set balance=balance+".$money." where id_user=1");
        return true;
    };
?>