<?php
/*
JS страница с рекламными ссылками
принимает get параметры
uid - идентификатор пользователя
f (0 или 1) - полный или сокращенный вид вывода рекламы
q - фраза поиска (utf)
max - максимальное количество ссылок
Проект zadanie.biz
Автор: Denvas
http://bmatrix.net/
*/
	require_once("config.php");
    require_once("config_modules.php");
	require_once("modules/flow/function.php");
	include_once("core/functionsql.php");
	//экспорт данных для JS
	header("Content-type: application/x-javascript; charset=utf-8");
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); //Дата в прошлом
	header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
	header("Pragma: no-cache"); // HTTP/1.0
	header("Last-Modified: ".date("r", time()));//обновлено сейчас
    
	global $global_flow;
	
	$code="";
	$maxselect=3;$type=1;
	if(isset($_GET["max"]))$maxselect=(int)$_GET["max"];if($maxselect<1)$maxselect=1;
	$ctime=time();
	if(isset($_GET["f"]))$type=(int)$_GET["f"];

	$user_agent=(isset($_SERVER['HTTP_USER_AGENT'])?strtr($_SERVER['HTTP_USER_AGENT'],array("\r"=>"","\n"=>"","|"=>"","<"=>"&lt;",">"=>"&gt;")):"");
	if(strpos($user_agent,"Opera Mini")!==false)
		$veruser="opera";
	//симбианы
	elseif(strpos($user_agent,"Symbian")!==false)
		$veruser="cellxhtml";
	//баузеры с компа
	elseif((strpos($user_agent,"Mozilla")===0)||(strpos($user_agent,"Windows")!==false)||(strpos($user_agent,"Linux")!==false))
		$veruser="comp";
	//это, наверное, какие-то сотовые версии wap2
	elseif((isset($_SERVER["HTTP_ACCEPT"]))&&(strpos($_SERVER["HTTP_ACCEPT"],"xhtml")!==false))
		$veruser="cellxhtml";
	//а это старые сотовые
	else
		$veruser="cellwml";
	
	$ip=(isset($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:"");
	if(strpos($user_agent,"Opera Mini")!==false){
		$user_agent="Opera Mini".(isset($_SERVER["HTTP_X_OPERAMINI_PHONE_UA"])?(" ".$_SERVER["HTTP_X_OPERAMINI_PHONE_UA"]):"");
	};//if
	//прокси
	$ipproxy=(!empty($_SERVER["HTTP_X_FORWARDED_FOR"]))?$_SERVER["HTTP_X_FORWARDED_FOR"]:"";
	//откуда кликнули
	$referer=isset($_SERVER['HTTP_REFERER'])?strtr($_SERVER['HTTP_REFERER'],array("\r"=>"","\n"=>"","|"=>"","<"=>"&lt;",">"=>"&gt;")):"";
	$user_agent_low=strtolower($user_agent);
	$lang=isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])?strtr($_SERVER['HTTP_ACCEPT_LANGUAGE'],array("\r"=>"","\n"=>"","|"=>"","<"=>"&lt;",">"=>"&gt;")):"none";
	$uid=isset($_GET["uid"])?(int)$_GET["uid"]:1;
	
	//это не прямой клик и здесь можно без рефера работать.
	if(empty($referer))$referer="http://".@$_SERVER['HTTP_HOST'].@$_SERVER["REQUEST_URI"];
	
	$operator=getoperatorGO($ip,$ipproxy);
	$finfo=array(
		"ver"=>$veruser,
		"user_agent"=>$user_agent,
		"user_agent_low"=>$user_agent_low,
		"lang"=>$lang,
		"id_user"=>$uid,
		"ip"=>$ip,
		"operator"=>$operator,
		"page"=>$referer,
		"hour"=>date("H"),
		"weekday"=>strtr(date("w"),array("0"=>"7")),
	);

	//папки, где хранится инфа о пользователе
	$pathname="users/".(500*(int)($uid/500))."/".$uid."/";
	if(!file_exists($pathname."clicks.php"))NotADVerror(1);
	require_once($pathname."clicks.php");
    //проверка на повторный клик
    $flag=0;
    if((empty($user_agent))||(strpos($user_agent,"http://")!==false))NotADVerror(2);
	//'этот вид рекламы не показывается при таком типе
	if($clicks_type==0)NotADVerror(3);

	//блокировка запрещенных реферов
	if((!$flag)&&(!empty($clicks_banreferer))&&($referer)){
		$databan=@file("data/banreferer.txt");
		$n=count($databan);
		for($i=0;$i<$n;$i++){
			$str=trim($databan[$i]);if(empty($str))continue;
			if(stristr($referer,$str)){
				$flag=6;
				break;
			};//if
		};//for
	};//if

	//блокировка запрещенных агентов
	if((!$flag)&&(!empty($clicks_banagent))&&($user_agent)){
		$databan=@file("data/banagent.txt");
		$n=count($databan);
		for($i=0;$i<$n;$i++){
			$str=trim($databan[$i]);if(empty($str))continue;
			if(stristr($user_agent,$str)){
				$flag=7;
				break;
			};//if
		};//for
	};//if

	//блокировка запрещенных IP
	if((!$flag)&&(!empty($clicks_banip))){
		$databan=@file("data/banipclick.txt");
		$n=count($databan);
		for($i=0;$i<$n;$i++){
			$str=trim($databan[$i]);if(empty($str))continue;
			if(strpos($ip,$str)===0){
				$flag=8;
				break;
			};//if
		};//for
	};//if
	
	if($flag)NotADVerror(4);//не подходит под клики
	
	if(!empty($_GET["q"])){
		$search=trim($_GET["q"]);
		$ifoa="or";
		$where="1=2";                
		$searcha=strtr($search,array(","=>" ",";"=>" ","."=>" ","!"=>" "));
		$searcha=mylower($search);
		$arr=explode(" ",$searcha);		
		$narr=count($arr);
		$k=0;
		for($i=0;$i<$narr;$i++){
			$s=trim($arr[$i]);
			if(strlen($s)<3)continue;
			if(isset($clicks_skipwords[$s]))continue;//слово в запрещенных или неважных
			$where.=" ".$ifoa." ( keywords like '% ".AddSlashes($s)."%')";
			$k++;if($k>3)break;
		};//for
	}
	else{
		$where="1=1";                
	};
	
	
	//выборка рекламы

	$nametemp="temp/expclick_".$uid."_".md5($where).".tmp";
	if(file_exists($nametemp)){
		$content=file_get_contents($nametemp);
		$oldtime=(int)substr($content,0,strpos($content,"\n"));
		$content=substr($content,strpos($content,"\n")+1);
	} else $oldtime=0;
	
	$adv=array();$nadv=0;
	
	if(time()-$oldtime>3*60){
		$newadv=array();
		$correctday=((int)date("H")*60+date("i"))/(24*60);
		SQLconnect();
	    $advdata=SQLarray("select id_user, id_link, url, balance, counterbalance, maxday, counterday, price, name, id_flow, description from clicks_links where status='active' and (maxday=0 or counterday<maxday*".$correctday.") and (".$where.") order by price desc limit 0,200",MYSQL_ASSOC);
		$ndata=count($advdata);
		if($ndata){
			for($i=0;$i<$ndata;$i++){
				$row=$advdata[$i];
				if(empty($row["name"]))continue;
				//превышен максимальный баланс
				if($row["balance"]<$row["price"]){
					SQLquery("update clicks_links set status='hidden' where id_link=".$row["id_link"]);
					continue;
				};
				//фильтры
				if($row["id_flow"]){
					if(empty($global_flow[$row["id_flow"]])){
						$global_flow[$row["id_flow"]]=SQLrow("select * from flow where id_flow=".$row["id_flow"]);
					};
				};
				$newadv[]=$row;
			};//for($i=0;$i<$ndata;$i++)
		};//if($ndata)
		SQLclose();
		$advdata=$newadv;$ndata=count($advdata);
		$fd=fopen($nametemp,"wb");
		fwrite($fd,time()."\n".serialize($advdata)."\n".serialize($global_flow));
		fclose($fd);
	}//if(time()-$oldtime>3*60)
	else{
		$data=explode("\n",$content);
		$advdata=unserialize($data[0]);$ndata=count($advdata);
		$global_flow=unserialize($data[1]);
	};//else
	
	//выборка подходящей рекламы
	for($i=0;$i<$ndata;$i++){
		$row=$advdata[$i];
		if($row["id_user"]==$uid)continue;
		//фильтры
		if($row["id_flow"]){
			$flow=$global_flow[$row["id_flow"]];					
			if(FlowFilter($finfo,$flow))continue;
		};
		$adv[]=$row;$nadv++;
		if($nadv>=$maxselect)break;
	};//for($i=0;$i<$ndata;$i++)
	
	//нет подходящей рекламы
	if(empty($adv))NotADVerror(5);
	//есть подходящая реклама
	$t=time();
	$ses=time();
	$code.="document.write(\"<div class='zadanieadv'>\");\n";
	for($i=0;$i<$nadv;$i++){
		$row=$adv[$i];
		$url="http://".$maindomain."/clicks.php?check=".md5($t.$row["id_link"].$ip.$user_agent.$antifraud_key)."&amp;t=".$t."&amp;uid=".$uid."&amp;go=".$row["id_link"];
		$row["description"]=strtr($row["description"],array("<br/>"=>"\n"));
		$code.="document.write(\"<a href='".$url."'>".$row["name"]."</a><br/>".($type?(rtrim($row["description"],"\n. !,")." <a href='".$url."'>...</a><br/>"):"")."\");\n";
	};
	$code.="document.write(\"&#x2191; Реклама от <a href='http://".$maindomain."/?uid=".$uid."'>zadanie.biz</a></div>\");\n";
	print $code;
    //==================================================//
	function NotADVerror($err=0){
		global $uid,$maindomain,$type;
		print "document.write(\"<div class='zadanieadv'>\");";
		if(mt_rand(0,1)==0)
			print "document.write(\"<a href='http://".$maindomain."/?uid=".$uid."'>Заработок в Интернет</a><br/>".($type?"Все виды заработков от простых до доходных<br/>":"")."\");\n";
		else
			print "document.write(\"<a href='http://".$maindomain."/?uid=".$uid."'>Раскрутка сайтов</a><br/>".($type?"Все виды раскрутки: покупка трафика, прямые ссылки, задания<br/>":"")."\");\n";
		print "document.write(\"&#x2191; Реклама от <a href='http://".$maindomain."/?uid=".$uid."'>zadanie.biz</a></div>\");\n";
		print "zadanieerr=".$err.";\n";
		exit;
	};
?>