alter table users add balance_banners float default 0, add banners_todayshow int default 0, add banners_todayclick int default 0, add banners_yesterdayshow int default 0, add banners_yesterdayclick int default 0;
alter table users add bannersbad_todayshow int default 0, add bannersbad_yesterdayshow int default 0;

DROP TABLE IF EXISTS banners;
create table banners
(
    id_banner int NOT NULL auto_increment,
    id_user int not null,
    status enum('moderate','active','ban','hidden','delete','banctr') default 'moderate',
    mime varchar(50) default 'image/gif',
    ext varchar(10) default 'gif',
    url varchar(255) default '',
    id_cat int default 0,
	id_flow int default 0,
	dayshow int default 0,
	editdate datetime default '0000-00-00',
	admindesc text default '',
	id_moder int default 0,
	banrules int default 0,
	
	bshow int default 0,
	bclick int default 0,
	
	btodayshow int default 0,
	btodayclick int default 0,
	
	ballshow int default 0,
	ballclick int default 0,
	
	endclick int default 0,
	primary key (id_banner),
	key(id_user),
    key(dayshow),
    key(bshow)
);

DROP TABLE IF EXISTS banners_statreferer;
create table banners_statreferer
(
    datestat date not null,
    id_user int not null,
    referer varchar(255),
    c int default 0,
       unique(id_user,referer),
       key(datestat),
       key(id_user)
);

DROP TABLE IF EXISTS banners_statagent;
create table banners_statagent
(
    datestat date not null,
    id_user int not null,
    agent varchar(255),
    c int default 0,
       unique(id_user,agent),
       key(datestat),
       key(id_user)
);
