DROP TABLE IF EXISTS buyref;
create table buyref
(
    id_buyref int not null auto_increment,  
    id_user int not null,                     
    datesend datetime,                        
    nref int default 0,
    moneyref float default 0,
    mindatereg datetime,

    price float default 0,                    
    status enum('moderate','active','deactive','done','ban') default 'moderate', 
        primary key(id_buyref),
        key(id_user),
        key(status)
);
