DROP TABLE IF EXISTS catalog_links;
create table catalog_links
(
    id_link int not null auto_increment,
    site varchar(255) not null,         
    id_user int not null,
	id_cat int default 0,
    title varchar(255) not null,
	description text,
	keywords text,
	status enum('moderate','active','ban','delete') default 'moderate',
    toptime int not null default 0,

    admindesc text default '',
	id_moder int default 0,
	banrules int default 0,

        primary key(id_link),
        key(id_user),
		key(site),
		key(status)
);
