alter table users add clicks_badyesterday int default 0, add clicks_clickyesterday int default 0;

DROP TABLE IF EXISTS clicks_links;
create table clicks_links
(
    id_link int NOT NULL auto_increment,                  
    url varchar(255) not null,                #рекламируемый сайт
    balance float default 0,               #бюджет кампании
    maxday int default 0,               #максимально кликов в сутки
    maxipday int default 0,               #максимально кликов в сутки с одного IP

    name varchar(255) default '',
	description text,
	keywords varchar(255) default '',
	
    status enum('hidden','active','delete','moderate','ban') default 'moderate', #статуст кампании
	banrules int default 0,
    id_user int not null default 0,           #кому пренадлежит ссылка
    counter int not null default 0,           #счетчик переходов
    counterbalance float default 0,
    counterday int not null default 0,        #количество кликов в текущий день
    admindesc text default '',                #комментарий
	id_moder int default 0,
    editdate datetime default '0000-00-00',   #дата регистрации
    checkview int default 0,

    price float default 0,
	
	id_flow int default 0,
	
       primary key (id_link),
       key(status),
       key(id_user),

       key(maxday),
       key(counterday),
	   key(keywords)
);

#уходы по ссылкам
DROP TABLE IF EXISTS clicks_go_links;
create table clicks_go_links
(
    id_link int not null,                #идентификатор ссылки
    id_user int not null,                #кликнувший юзер
    ip varchar(255) default '', #айпишник клика
    user_agent varchar(255) default '',
    amount float default 0,
	oper varchar(255) default '',
    t int default 0,                     #время клика
        key(id_link),
        key(id_user)
);

DROP TABLE IF EXISTS clicks_statreferer;
create table clicks_statreferer
(
    datestat date not null,
    id_user int not null,
    referer varchar(255),
    c int default 0,
       unique(id_user,referer),
       key(datestat),
       key(id_user)
);

DROP TABLE IF EXISTS clicks_statagent;
create table clicks_statagent
(
    datestat date not null,
    id_user int not null,
    agent varchar(255),
    c int default 0,
       unique(id_user,agent),
       key(datestat),
       key(id_user)
);
