DROP TABLE IF EXISTS exchange_money;
create table exchange_money
(
    id_exchange int not null auto_increment,  
    etype enum('banners') not null,
    id_user int not null,                     
    datesend datetime,                        
    startbalance int default 0,
    balance int default 0,                    
    price float default 0,                    
    status enum('active','deactive','done') default 'active', 
        primary key(id_exchange),
        key(id_user),
        key(etype)
);
