DROP TABLE IF EXISTS inmail;
create table inmail
(
    id_mail int not null auto_increment,      #идентификатор
    id_user int not null,                     #у кого в ящике лежит
    id_contact int not null,                  #с кем контактировал (от кого или кому)
    datesend datetime,
    folder enum('fin','fout','fdel','fauto'),         #входящее, исходящие или удаленное
    subj varchar(255) default '',             #тема
    message text,                             #сообщение
    status enum('new','view') default 'new',
        primary key(id_mail),
        key(id_user),
        key(status)
);
