DROP TABLE IF EXISTS ticket;
create table ticket
(
    id_ticket int not null auto_increment, #идентификатор
    status enum('new','aswered','view','close'),          #статус "заданый вопрос", "отвечено", "ответ посмотрен"
    subject varchar(255),                  #тема сообщения
    id_user int not null,                  #идентификатор пользователя
    datesend datetime,                         #время добавления
    primary key(id_ticket),
    key(status),
    key(id_user)
);

#посты тикетов
DROP TABLE IF EXISTS ticketpost;
create table ticketpost
(
    id_post int not null auto_increment,   #идентификатор
    id_ticket int,                         #идентификатор тикета
    id_user int not null,                  #идентификатор пользователя
    datesend datetime,                         #время добавления
    message text,                      #описание проблемы
    primary key(id_post),
    key(id_ticket)
);
