<?php
/*
Регистрация с повышенной защитой от накруток:
1. Запрос картинки.
2. Код активации на мыло
3. Защита от нескольких рег на одно мыло
4. Защита от регистрации с одного IP и Agent за последние несколько минут
Автор: Denvas
http://bmatrix.net/
*/

    include_once("config.php");
    include_once("core/secure.php");
    include_once("core/functionsql.php");

    data_header();
    //==================================================//
    function EndRegistration($id_user,$info,$id_parent=0){
        global $banner_name;
        //занесение вышестоящих в список
        $parent=trim($id_parent.",".SQLone("select parentdeep from users where id_user=".$id_parent),",");
        $elem=explode(",",$parent);$nelem=count($elem);if($nelem>10)$nelem=10;
        $parent="";for($i=0;$i<$nelem;$i++)$parent.=$elem[$i].",";
        SQLquery("update users set refcount=refcount+1 where id_user=".$id_parent);
        SQLquery("update users set parentdeep='".trim($parent,",")."' where id_user=".$id_user);
        //создание структуры каталогов для пользователей
        $name="users/".(500*(int)($id_user/500))."/";
        if(!file_exists($name)){
            @mkdir($name,0777);@chmod($name, 0777);
        };
        $name.=$id_user."/";
        @mkdir($name,0777);@chmod($name, 0777);

    };//function EndRegistration
    //==================================================//
	$crumbs[]=array(QueryParam(array(),1,"index.php"),"Главная");
    //проверка закрытости регистрации
    if(file_exists($path_data."/noreg.txt")){
        $code=design("Регистрация","header");
        $code.=design(file_get_contents($path_data."/noreg.txt"),"warning");
    }
    //конец регистрации
    elseif(isset($_GET["end"])){
		$crumbs[]=array(QueryParam(array("end"),1),"Окончание регистрации");
        $id_user=(int)$_GET["end"];
        setcookie("zadanie_id",$id_user,time()+30*24*60*60,$curpath);
        if(isset($_GET["pwd"])){
            $urllogin=QueryParam(array(),1,"login.php")."ul=".$id_user."&amp;up=".$_GET["pwd"];
            list($codetext,$title)=ViewText("reg",array(TMPL."id_user".TMPL=>$id_user,TMPL."id_site".TMPL=>$id_user,TMPL."pwd".TMPL=>$_GET["pwd"],TMPL."urllogin".TMPL=>$urllogin));
            $code.=design($title,"header");
            $code.=$codetext;
        }//if(isset($_GET["pwd"]))
        else{
            $urllogin=QueryParam(array(),1,"login.php")."ul=".$id_user;
            list($codetext,$title)=ViewText("regmail",array(TMPL."id_user".TMPL=>$id_user,TMPL."id_site".TMPL=>$id_user,TMPL."urllogin".TMPL=>$urllogin));
            $code.=design($title,"header");
            $code.=$codetext;
        };
    }
    else{
        $showform=0;
        $code=design("Регистрация","header");
		$crumbs[]=array(QueryParam(array(),1),"Регистрация");
        $auth=GetUserInfo();
        if($auth)Relocation(QueryParam(array(),1,"member.php"),"Вы уже зарегистрированы. Вход в систему");
        if(!empty($_POST["send"])){
            $showform=0;
            if(empty($regemailcheck))
                $data["up"]=$_POST["up"];
            else
                $data["up"]=rndstr(6);
            $data["email"]=strtolower($_POST["email"]);
            $data["site"]=!empty($_POST["site"])?strtolower($_POST["site"]):"";
			$data["phone"]=trim($_POST["phone"]);
			global $filterinput;
			$filterinput["NUMPHONEREG"]=array("^\+[0-9]{10,15}$","только цифры",1,array(),array(""=>1,"+7"=>1));
			
            if(!checkinput($data["site"],"SITE",true)){$showform=1;$code.=design("Заполните правильно адрес сайта","error");};
            if(!checkinput($data["up"],"PASSWORD",false)){$showform=1;$code.=design("Заполните пароль. Формат:".formatinput("PASSWORD"),"error");};
            if(!checkinput($data["email"],"MAIL",false)){$showform=1;$code.=design("Заполните e-mail. Формат:".formatinput("MAIL"),"error");}
			elseif(strpos($data["email"],"wapalta.mobi")!==false){$showform=1;$code.=design("Регистрация на этот e-mail запрещена","error");};
            if(!checkinput($data["phone"],"NUMPHONEREG",true)){$showform=1;$code.=design("Заполните правильно номер сотового телефона. Он должен начинаться со знака + и далее полный номер в федеральном формате.","error");};
			
            if(!SecureCheck($_POST["checksum"],$_POST["antispam"])){$showform=1;$code.=design("Повторите ввод цифр","error");sleep(3);};

            //защита от простых паролей
            if(!$showform){
                $namemail=explode("@",$data["email"]);
                if(strcmp($data["up"],"demo")==0)$showform=1;
                elseif(strcmp($data["up"],"123")==0)$showform=1;
                elseif(strcmp($data["up"],"asd")==0)$showform=1;
                elseif(strcmp($data["up"],"qwe")==0)$showform=1;
                elseif(strcmp($data["up"],$namemail[0])==0)$showform=1;
                elseif(strcmp($data["up"],$namemail[1])==0)$showform=1;
                if($showform)$code.=design("Придумайте другой пароль","error");
            };
            if(!$showform){
                SQLconnect();
				if(isset($_COOKIE["zadanie_id"])){
					$zadanie_id=explode(".",$_COOKIE["zadanie_id"]);
					$zadanie_id[0]=(int)$zadanie_id[0];
					if(isset($zadanie_id[1])){
						$checkpwd=SQLone("select pwd from users where id_user=".$zadanie_id[0]);
						if(strpos($checkpwd,$zadanie_id[1])===0){
							$doublesession=(int)$zadanie_id[0];
							SaveLog("doublereg","new|".$doublesession);
						};
					};//if(isset($zadanie_id[1]))
				};//if(isset($_COOKIE["zadanie_id"]))
				if(!empty($doublesession)){
					$code.=design("Повторная регистрация! По правилам системы запрещено регистрировать несколько аккаунтов.","error");
				}
                elseif(SQLone("select count(id_user) from users where email='".AddSlashes($_POST["email"])."'",0)>=$antifraud_maxemail){
                    $code.=design("Пользователь с таким e-mail уже зарегистрирован","error");
                }
                elseif(SQLone("select id_user from users where user_agent='".AddSlashes($user_agent)."' and ip='".AddSlashes($ip)."' and regdate>'".date("Y-m-d H:i:s", time()-$antifraud_reg)."'",0)){
                    $code.=design("Превышен лимит регистраций. Попробуйте попозже","error");
                }
                elseif(($antifraud_regday)&&(SQLone("select count(*) from users where  regdate>'".date("Y-m-d H:i:s", time()-24*60*60)."'",0)>$antifraud_regday)){
                    $code.=design("Превышен суточный лимит регистраций. Попробуйте завтра.","error");
                }
                else{
					if(!empty($_GET["uid"])){
						$uid_ref=(int)$_GET["uid"];
					}
					elseif(!empty($_COOKIE["uid"])){
						$uid_ref=(int)$_COOKIE["uid"];
					};
                    if(!empty($uid_ref)){
                        $id_parent=SQLone("select id_user from users where id_user=".$uid_ref,0);
                    };
                    if(empty($id_parent))$id_parent=1;
                    $check=mt_rand(1000,9999);
                    SQLquery("insert into users set regdate=NOW(), status='".AddSlashes($antifraud_regstatus)."', checkkey='".$check."', id_parent=".$id_parent.", balance=".$bonusreg.", minbalance=".$bonusreg.", email='".AddSlashes($data["email"])."', phone='".AddSlashes($data["phone"])."', pwd='".md5($data["up"])."', site='".AddSlashes($data["site"])."', user_agent='".AddSlashes($user_agent)."', ip='".AddSlashes($ip)."';");
                    $id_userreg=mysql_insert_id($LinkSQL);
                    EndRegistration($id_userreg,$data,$id_parent);
                    CheckProfile($id_userreg,$ip,$user_agent);
                    SendMailTemplate($_POST["email"],"reg",array(TMPL."id_user".TMPL=>$id_userreg,TMPL."pwd".TMPL=>$data["up"]));
                    Relocation(QueryParam(array("rules"))."end=".$id_userreg.((empty($regemailcheck))?("&amp;pwd=".$data["up"]):""),"",-1);
                };
                SQLclose();
            };
        }
        else{
            $data["site"]="";
            $data["up"]="";
            $data["email"]="";
            $data["login"]="";
			$data["phone"]="+7";
            //правила
            list($codetext,$title,$keyword,$metadescription)=ViewText("reginfo");
            $code.=$codetext;
	        if(isset($_COOKIE["zadanie_id"])){
	            $code.=design("По нашим сведениям у Вас уже есть аккаунт в системе.<br/>Повторная регистрация запрещена.<br/>Чтобы избежать недоразумений, читайте правила системы.","warning");
	        };
        };//else

        list($num,$img,$checksum)=SecureImage(NumImg());
        $dataform=array();
        $dataform[]=array("Ваш e-mail (на него будет выслан пароль) *","email",$data["email"],"text");
        if(empty($regemailcheck))$dataform[]=array("Желаемый пароль *","up",$data["up"],"text");
		$dataform[]=array("Номер сотового (в федеральном формате)","phone",$data["phone"],"text");
        $dataform[]=array("Введите цифры".$img,"antispam","","text");
        $dataform[]=array("","checksum",$checksum,"hidden");
        $code.=ShowForm($dataform,"Регистрировать");
		$code.=design("Номер сотового будет использоваться для денежных операций и восстановления доступа к аккаунту.<br/>Если не видно картинки, возможно, у Вас отключен показ изображений.<br/>Если невозможно разобрать изображение на картинке, <a href='".QueryParam(array("rnd"))."'>перезагрузите</a> страницу.","info");
        HeaderCache();//запрет кеширования
    };
	$code.=ADV(0,1);
    data_bottom(isset($template["mainfree"])?"mainfree":"main");
    ShowXML($code);
    //==================================================//
function rndstr($len,$s="123456789QWERTYUPASDFGHJKLZXCVBNM"){
    $str='';
    mt_srand((double)microtime()*1000000);
    $ls=strlen($s)-1;
    for($i=0;$i<$len;$i++){
        $n=mt_rand(0,$ls);
        $str.=$s[$n];
    };
    return $str;
};
?>