<?php
/*
Запуск по таймеру раз в несколько минут для обновления баланса рекламодателей
Автор: Denvas
*/
    if(!extension_loaded('mysql')) {
        if(!dl('mysql.so')){print "Not load mysql\n";exit;};
    };

    chdir(dirname(__FILE__)."/..");
    include_once("config.php");//путь до конфигурационного файла
    include_once("core/functionsql.php");
    include_once("core/money.php");
    include_once("config_modules.php");
	
    $fd_lock=fopen("temp/bannersstat.lock","w");
    if(!flock($fd_lock,LOCK_EX|LOCK_NB)){print "Locked\n";exit;};
    fwrite($fd_lock,time());

    @set_time_limit(0);//выполнять без ограничений

    print time()."\n";
    $moneyadmin=0;
	
    SQLconnect();
	
	//блок обработки показов и кликов
	$name1="data/bannerslog/show_click.log";
	if(file_exists($name1)){
		$name2=$name1.".tmp";
		rename($name1,$name2);
		$data=file($name2);
		$minus=array();
		$plus=array();
		$minus2=array();
		$statref=array();
		$statagent=array();
		$ndata=count($data);
		for($i=0;$i<$ndata;$i++){
			$row=explode("|",$data[$i]);
			list($type,$id_from,$id_to,$id_banner,$filter)=$row;
			$id_from=(int)$id_from;
			$id_to=(int)$id_to;
			$id_banner=(int)$id_banner;
			if((empty($id_banner))||(empty($id_to))){
				print "Banners error\n";
				print_r($row);
				$fd=fopen("logs/banners".time().".log","wb");
				fwrite($fd,join($data));
				fclose($fd);
			};
			//статистика для отъема денег
			if(empty($minus[$id_to."_".$id_banner]))$minus[$id_to."_".$id_banner]=array(0,0,$id_banner);
			$r=&$minus[$id_to."_".$id_banner];
			//показ баннера
			if($type==0){
				$r[0]++;
				if(empty($minus2[$id_to]))$minus2[$id_to]=0;
				$minus2[$id_to]+=1+$banners_perc_system;
				if($id_to!=1)$moneyadmin+=$banners_perc_system;
				if($filter){//при фильтрации увеличивать процент съема денег
					$minus2[$id_to]+=$banners_perc_system_flow;
					if($id_to!=1)$moneyadmin+=$banners_perc_system_flow;
				};
			}
			//клик по баннеру
			else{
				$r[1]++;
			};
			//статистика для начисления денег
			if(empty($plus[$id_from]))$plus[$id_from]=array(0,0,0);
			$r=&$plus[$id_from];
			//показ баннера
			if($type==0){
				$r[0]++;
				$r[2]+=1-$banners_perc_system;
				if($id_from!=1)$moneyadmin+=$banners_perc_system;
				$agent=empty($row[5])?"not":$row[5];
				$referer=empty($row[6])?"not":$row[6];
				$referer=explode("?",$referer);$referer=$referer[0];//до знака вопроса. иначе очень много страниц
				if(empty($statagent[$id_from][$agent]))$statagent[$id_from][$agent]=1; else $statagent[$id_from][$agent]++;
				if(empty($statref[$id_from][$referer]))$statref[$id_from][$referer]=1; else $statref[$id_from][$referer]++;
			}
			//клик по баннеру
			else{
				$r[1]++;
			};
		};//for($i=0;$i<$ndata;$i++)
		//отнять деньги за показ баннеров
		reset($minus2);
		while(list($key,$val)=each($minus2)){
			SQLquery("update users set balance_banners=balance_banners-".$val." where id_user=".$key);
		};
		//обновить статистику показа баннеров
		reset($minus);
		while(list($key,$val)=each($minus)){
			SQLquery("update banners set bshow=bshow+".$val[0].", bclick=bclick+".$val[1].", ballshow=ballshow+".$val[0].", ballclick=ballclick+".$val[1].", endclick=".time()." where id_banner=".$val[2]);
		};
		//прибавить деньги за показы (только полльзователям у которых статус 'active')
		reset($plus);
		while(list($key,$val)=each($plus)){
			SQLquery("update users set banners_todayshow=banners_todayshow+".$val[0].", banners_todayclick=banners_todayclick+".$val[1].", balance_banners=balance_banners+".$val[2]." where status='active' and id_user=".$key);
		};
		//статистика страниц где размещен баннер и бразеров которым он показывался
		reset($statagent);
		while(list($id_user,$arr)=each($statagent)){
			while(list($val,$c)=each($arr)){
				SQLquery("insert into banners_statagent set datestat=NOW(), id_user=".$id_user.", agent='".AddSlashes($val)."', c=".$c." ON DUPLICATE KEY UPDATE datestat=NOW(), c=c+".$c);
			};
		};
		reset($statref);
		while(list($id_user,$arr)=each($statref)){
			while(list($val,$c)=each($arr)){
				SQLquery("insert into banners_statreferer set datestat=NOW(), id_user=".$id_user.", referer='".AddSlashes($val)."', c=".$c." ON DUPLICATE KEY UPDATE datestat=NOW(), c=c+".$c);
			};
		};
		
		unlink($name2);
		//доход администрации от баннерной сети
		$systempay=$moneyadmin*$banners_buysystem/1000;
		print "System pay: ".$systempay."\n";
		SystemMoney(0,$systempay);
	};//if(file_exists($name1))
	global $global_flow;
	$correctday=((int)date("H")*60+date("i"))/(24*60);
	$databanner=array();$bannergo=array();$global_flow=array();
	$data=SQLarray("select id_user, balance_banners from users where balance_banners>7 order by balance_banners desc");
	$code="";$allbalance=0;$k=0;$userlist="";
	$ndata=count($data);
	for($j=0;$j<$ndata;$j++){
		$row=$data[$j];		
		//выбрать баннеры с учетом количества показов в сутки. количество показов для id1 не учитывается
		$banners=SQLarray("select id_banner, id_cat, id_flow, mime, url, dayshow, bshow, bclick from banners where status='active' and id_user=".$row[0].(($row[0]!=1)?(" and (dayshow=0 or bshow<dayshow*".$correctday.")"):""));
		$nbanners=count($banners);
		$flaglist=0;
		for($i=0;$i<$nbanners;$i++){
			$r=$banners[$i];
			if($r[2]){
				if(empty($global_flow[$r[2]])){
					$global_flow[$r[2]]=SQLrow("select * from flow where id_flow=".$r[2]);
				};
			};			
			$b=round($row[1]/$nbanners)-1;
			if(($r[5]>0)&&($b>$r[5]-$r[6]))$b=$r[5]-$r[6];
			if($b<1)$b=1;
			$ctr=$r[6]?round($r[7]/$r[6],3):0;
			if($ctr)$flaglist++;
			$databanner[]=array($k,$row[0],$b,$r[0],$r[1],$r[2],$r[3],$r[4],$ctr);
			$bannergo[$r[0]]=array($k,$row[0],$b,$r[0],$r[1],$r[2],$r[3],$r[4]);
			$allbalance+=$b;
			$k++;
		};//for($i=0;$i<$nbanners;$i++)
		if($flaglist)$userlist.="|".$row[0]."|\n";
	};
	//запись баннеров
	$namebanners="data/bannerslog/banners.php";
	$fd=fopen($namebanners,"wb");
	fwrite($fd,"<?php\n\$allbalance=".$allbalance.";\n\$databanner=".var_export($databanner,true).";\n?".">");
	fclose($fd);
	@chmod($namebanners,0666);
	//запись фильтров
	$namebanners="data/bannerslog/flow.php";
	$fd=fopen($namebanners,"wb");
	fwrite($fd,"<?php\n\$dataflow=".var_export($global_flow,true).";\n?".">");
	fclose($fd);
	@chmod($namebanners,0666);
	//запись ссылок
	$namebanners="data/bannerslog/bannergo.php";
	$fd=fopen($namebanners,"wb");
	fwrite($fd,"<?php\n\$bannergo=".var_export($bannergo,true).";\n?".">");
	fclose($fd);
	@chmod($namebanners,0666);
	//запись списка всех пользователей, которые в данный момент показывают баннеры
	$namebanners="data/bannerslog/buserlist.txt";
	$fd=fopen($namebanners,"wb");
	fwrite($fd,$userlist);
	fclose($fd);
	@chmod($namebanners,0666);
	//записать всех у кого сегодня ctr ниже $banners_minctr
	$data=SQLarray("select id_user, banners_todayshow, banners_todayclick, banners_yesterdayshow from users where (banners_todayshow>30 and banners_todayclick/banners_todayshow<".($banners_minctr*1.1).")");
	$ndata=count($data);
	$code.="|";
	for($i=0;$i<$ndata;$i++){
		$row=$data[$i];
		if($row[2]/$row[1]>$banners_minctr)$perc=1;//засчитывать каждый второй баннер
		elseif($row[1]<50)$perc=1;//засчитывать каждый второй баннер
		elseif($row[1]<70)$perc=2;//засчитывать каждый третий баннер
		elseif($row[1]<100)$perc=5;//каждый пятый
		elseif($row[2]/$row[1]>$banners_minctr*0.7)$perc=7;//каждый седьмой
		elseif($row[2]/$row[1]>$banners_minctr*0.5)$perc=20;//каждый двадцатый
		else $perc=0;//не засчитывать пока не поднимится ctr
		$code.=$row[0].":".$perc."|";
	};//for($i=0;$i<$ndata;$i++)
	//print $code."\n";
	$namebanners="data/bannerslog/noshow.txt";
	$fd=fopen($namebanners,"wb");
	fwrite($fd,$code);
	fclose($fd);
	@chmod($namebanners,0666);
	
	//занести в базу незасчитанные клики
	$namebanners="data/bannerslog/bad.log";
	if(file_exists($namebanners)){
		$data=file($namebanners);
		unlink($namebanners);
		$n=count($data);
		$bad=array();
		for($i=0;$i<$n;$i++){
			$row=explode("|",$data[$i]);
			if(empty($row[0]))continue;
			if(empty($bad[$row[0]]))$bad[$row[0]]=1; else $bad[$row[0]]++;
		};
		print "BAD\n";
		reset($bad);
		while(list($key,$val)=each($bad)){
			print $key." ".$val."\n";
			SQLquery("update users set bannersbad_todayshow=bannersbad_todayshow+".$val." where id_user=".$key);
		};
	};

    SQLclose();
	
    fclose($fd_lock);
    print "Ok\n";
?>